<?php 
/**
 * @package  WooadvaricsPlugin
 */
defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' );



class AdbxERPConnection {
	
	public $erp_id;
	
	public $advarics_api_url;
	
	public $adiabax_id;
	
	//protected $result;
	
	//protected $output_array = array();
	
	function __construct() {

		if ( is_null( $this->erp_id ) ) 
			$this->erp_id = get_option( 'adbx_advarics_id' );
		
		if ( is_null( $this->advarics_api_url ) ) 
			$this->advarics_api_url = get_option( 'adbx_advarics_api_url' );
		
		if ( is_null( $this->adiabax_id ) ) 
			$this->adiabax_id = get_option( 'adbx_license_key' );
		
	}

}


class AdbxSynchWooAdvarics extends AdbxERPConnection {
	
	private $advarics_get_array = array();
	
	protected $result;
	
	protected $output_array = array();
	
	public $erp_json_response;
	
	
	function adbxExecSynchronization( $synch_type ) 
	{
		
		$previous_synch 	= ADBX_ERP_FILE;
		$previous_synch_key = ADBX_ERP_KEY_FILE;
		// Get Running process 
		$dormi = rand(0,5); //per evitare sovrapposizioni di processi synch
		sleep($dormi);
		
		$adbx_now 			= strtotime(date("Y-m-d H:i:s"));
		$adbx_running_synch = strtotime(get_option('adbx_running_synch'));
		//$adbx_diff_synch 	= $adbx_now - $adbx_running_synch;
		if ( ($adbx_now - $adbx_running_synch) < 180 )
		{	
			Logger::adbxWriteLog( 'Synchronization aborted as previous synch still running!');
			return false; //previous synch still running
		}
		
		update_option( 'adbx_running_synch', date("Y-m-d H:i:s") ); 
		//date_default_timezone_set("CET");
		
		$last = get_option('adbx_advarics_changedAt');
		$last_update_unix 		= strtotime( $last );
		$adjsted_update_unix 	= $last_update_unix - 60*3;
		
		$advarics_get_array = array(
			'id' => $this->erp_id,
			'url' => adbx_python_crypt($this->advarics_api_url,'e',1),
			'dominio' => adbx_python_crypt(get_site_url(),'e',1), 
			'id_licenza' => adbx_python_crypt($this->adiabax_id,'e',1)
			);
		
		if 	( $synch_type <> 9)
		{
			if ( get_option('adbx_advarics_productlist_synch') == 1)
			{
				$last_update_settings 				= get_option('adbx_advarics_changedAt');
				$last_update_unix 					= strtotime( $last_update_settings ) - 60*3;
				$advarics_get_array['last_update'] 	= date("Y-m-d\TH:i:s.000\Z", $last_update_unix);
			}
			elseif ( get_option('adbx_advarics_productlist_synch') == 2)
				$advarics_get_array['product_list'] = get_option('adbx_advarics_single_item_ID');
		}	
				
		if ( (file_exists($previous_synch_key)) AND (filesize($previous_synch_key) > 20) AND ( $synch_type <> 9) ) 
		{
			$contents = file_get_contents( $previous_synch );
			Logger::adbxWriteLog( 'Continuation of the previous synchronization that did not finish!');
			$messagestring = 'PREVIOUS SYNCH RELOADED, SYNCH AGAIN TO LOAD RECENT UPDATES';
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>' . $messagestring . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';

		}	
		else
		{
			
			//$contents 	= file_get_contents(get_template_directory() . '/local.json');	
			$contents = adbx_run_servertemplate( ADBX_SYNCH_URL, $advarics_get_array );
			
			if ( ( $synch_type <> 9 ) AND ( $synch_type <> 0 ) )
			{
				$this->adbxRunSynch( $contents );
				
				/*
				$array_response_synch = json_decode($contents, true); //ARRAY
				
				if (array_key_exists( 'success',  $array_response_synch) == FALSE) 
				{	
					$logfile = fopen($previous_synch, 'w');  
					fwrite($logfile, $contents);
					fclose($logfile); 

					$num_record 	= count($array_response_synch["articles"]);
					$adbx_array_key = array();
					
					for ($i=0;$i<$num_record; $i++)
					{
						$adbx_array_key[$i]['pos'] = $i;
						$adbx_array_key[$i]['key'] = $array_response_synch["articles"][$i]["articleId"];
					}
					
					$tmp_file = fopen($previous_synch_key, 'w');  
					fwrite($tmp_file, json_encode($adbx_array_key) );
					fclose($tmp_file);	
					
					if ( get_option('adbx_advarics_productlist_synch') <> 2)
					{	
						if (array_key_exists( 'last_update',  $array_response_synch)) 
							$last_update = $array_response_synch["last_update"];
						else
							$last_update = date("Y-m-d H:i:s");
						
						update_option( 'adbx_advarics_changedAt', $last_update );
					}	
				}
				else
				{
					echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>' . $array_response_synch["message"] . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';
					if ( file_exists(ADBX_ERP_FILE) ) 	
						$deleted_files 	= unlink(ADBX_ERP_FILE);
					return false;
				}
				*/				
				
			}
	
		}	
		
		if ($contents)
		{	

			$this->erp_json_response = $contents;
			return true;
		}	
		else
			return false;
		
	}
	
	function adbxRunSynch( $contents )
	{
		$array_response_synch = json_decode($contents, true); //ARRAY
		
		if (array_key_exists( 'success',  $array_response_synch) == FALSE) 
		{	
			$logfile = fopen(ADBX_ERP_FILE, 'w');  
			fwrite($logfile, $contents);
			fclose($logfile); 

			$num_record 	= count($array_response_synch["articles"]);
			$adbx_array_key = array();
			
			for ($i=0;$i<$num_record; $i++)
			{
				$adbx_array_key[$i]['pos'] = $i;
				$adbx_array_key[$i]['key'] = $array_response_synch["articles"][$i]["articleId"];
			}
			
			$tmp_file = fopen(ADBX_ERP_KEY_FILE, 'w');  
			fwrite($tmp_file, json_encode($adbx_array_key) );
			fclose($tmp_file);	
			
			if ( get_option('adbx_advarics_productlist_synch') <> 2)
			{	
				if (array_key_exists( 'last_update',  $array_response_synch)) 
					$last_update = $array_response_synch["last_update"];
				else
					$last_update = date("Y-m-d H:i:s");
				
				update_option( 'adbx_advarics_changedAt', $last_update );
			}	
		}
		else
		{
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>' . $array_response_synch["message"] . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';
			if ( file_exists(ADBX_ERP_FILE) ) 	
				$deleted_files 	= unlink(ADBX_ERP_FILE);
			return false;
		}
	}
	
	
	function adbxBlockSplitAndSchedule() { 
		
		$array_request	= json_decode($this->erp_json_response, true);
		$num_record 	= count($array_request["articles"]);
		
		$block_size	= get_option('adbx_advarics_block_size');
		if ($block_size) 
			$blocco = $block_size;
		else
			$blocco = ADBX_SYNCH_BLOCK;
		
		
		$num_proc = ceil($num_record / $blocco);
		
		if ($num_record == 0)
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>No new updates available</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';
		else	
		{	
			for ($i=0;$i<$num_proc; $i++)
			{
				$init_blocco = $i*$blocco;
				$end_blocco = $init_blocco + $blocco;
				if ($end_blocco > $num_record )
					$end_blocco = $num_record;
				
				wp_schedule_single_event(time()+ 10,'wooadvarics_process_load', array( $init_blocco, $end_blocco, $this->erp_json_response), true );
				echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>Synch block nr. ' . ($i+1) . ' started ( ' . $end_blocco .  ' )</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';

			}
		}
				
		return true;

    }
	
	
	function adbxImmediateSynch() { 
		
		$array_request	= json_decode($this->erp_json_response, true);
		$num_record 	= count($array_request["articles"]);
		
		$synch_instance = new AdbxWooProductsUpdate();
		$synch_instance->adbxExecUpdate( 0, $num_record , $this->erp_json_response );
		
		echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>Synchronization of ' . $num_record .  ' products</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';

		return true;

    }
	
	
	function adbxSendOrderERP( $json_order ) 
	{
		
		$advarics_order_array = array(
			'id' => $this->erp_id,
			'url' => adbx_python_crypt($this->advarics_api_url,'e',1),
			'dominio' => adbx_python_crypt(get_site_url(),'e',1), 
			'id_licenza' => adbx_python_crypt($this->adiabax_id,'e',1),
			'order_jsn' => $json_order
		);
		
		//$contents = file_get_contents($url, false, $context);
		$contents = adbx_run_servertemplate( ADBX_INSERT_ORDER_URL, $advarics_order_array );
		$contents = utf8_encode($contents); // JSON
				
		return $contents;
	}	
	
	
	public function adbxCancelERPOrder( $json_order, $action ) 
	{
			
		$advarics_order_array = array(
			'id' => $this->erp_id,
			'url' => adbx_python_crypt($this->advarics_api_url,'e',1),
			'dominio' => adbx_python_crypt(get_site_url(),'e',1), 
			'id_licenza' => adbx_python_crypt($this->adiabax_id,'e',1),
			'order_jsn' => $json_order,
			'action' => $action
		);
		
		//$contents = file_get_contents($url, false, $context);
		$contents = adbx_run_servertemplate( ADBX_CANCEL_ORDER_URL, $advarics_order_array );
		$contents = utf8_encode($contents); // JSON
		
		return $contents;
	}	
	
	
	function adbxExtraAttributes( $attribute_type) { 
		
		$extra_attributes_array = array();
		
		$array_request	= json_decode($this->erp_json_response, true);
		$num_record 	= count($array_request["articles"]);
		
		if ($attribute_type == 'attrib')
		{
			for ($i=0;$i<$num_record; $i++)
			{
				$num_attributes = count($array_request["articles"][$i]['articleAttributs']);
				for ($j=0;$j<$num_attributes;$j++)
					array_push($extra_attributes_array, $array_request["articles"][$i]['articleAttributs'][$j]['typeName']);
			}
		}
		elseif ($attribute_type == 'text')
		{
			for ($i=0;$i<$num_record; $i++)
			{
				$num_attributes = count($array_request["articles"][$i]['articleTexts']);
				for ($j=0;$j<$num_attributes;$j++)
					array_push($extra_attributes_array, $array_request["articles"][$i]['articleTexts'][$j]['typeName']);
			}
		}
		
		return array_unique($extra_attributes_array);

    }
	
	
	public function adbxSynchStatusOrder() 
	{
			
		$advarics_orderstatus_array = array(
			'id' => $this->erp_id,
			'url' => adbx_python_crypt($this->advarics_api_url,'e',1),
			'dominio' => adbx_python_crypt(get_site_url(),'e',1), 
			'id_licenza' => adbx_python_crypt($this->adiabax_id,'e',1)
		);

		//$contents = file_get_contents($url, false, $context);
		$contents = adbx_run_servertemplate( ADBX_ORDER_STATUS_URL, $advarics_orderstatus_array );
		
		if ($contents)
		{	
			$this->erp_json_response = utf8_encode($contents);
			return true;
		}	
		else
			return false;
		
	}
	
	
	function adbxUpdateStatusWooOrders( $synch_type) { 
		
		$array_request	= json_decode($this->erp_json_response, true);
		if ($array_request)
			$num_record 	= count($array_request["orders"]);
		else
			$num_record = 0;
		$num_updates	= 0;
		
		/*
		Advarics                              		WooCom
		1	Offen                                 	Zahlung ausstehend   - pending  (Bei Zahlart „Vorkasse“)
		2	In Bearbeitung                 			In Wartestellung     - on-hold        (Bei allen übrigen Zahlarten wie Paypal, Amazon etc)
		3	Kommissioniert                			In Bearbeitung		 - processing
		4	Rechnung erstellt            			Abgeschlossen		 - completed
		9	Storniert                             	Storniert/Abgebrochen - cancelled
		*/
		
		for ($i=0;$i<$num_record; $i++)
		{
			$erp_order_id 		= $array_request["orders"][$i]['orderId'];
			$erp_order_status 	= $array_request["orders"][$i]['status'];
			switch ($erp_order_status) {
					case 1:
						$erp_order_status_def = 'pending';
						break;
					case 2:
						$erp_order_status_def = 'on-hold';
						break;
					case 3:
						$erp_order_status_def = 'processing';
						break;
					case 4:
						$erp_order_status_def = 'completed';
						break;	
					case 9:
						$erp_order_status_def = 'cancelled';
						break;
					default:
						$erp_order_status_def = 'on-hold';
						break;

			} 
	
			$orders = wc_get_orders( array(
				'meta_key'     => 'erp_orderid', 
				'meta_value' => $erp_order_id, 
			));
			
			
			
			foreach($orders as $order)
			{
				$order_id 		= $order->get_id();
				$order_status 	= $order->get_status();
				
				if ($order_status ===  $erp_order_status_def)
				{	
					continue;
				}	
				elseif (!empty($order))
				{
						$order->update_status( $erp_order_status_def );
						if ( $synch_type == 0) // Manual
							echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>Status of order nr. ' . $order_id . ' updated to: ' . $erp_order_status_def .  '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';
						$num_updates++;
						Logger::adbxWriteLog('Update Order Status Synch: Erp_order_id-> ' .  $erp_order_id .  ', Erp_order_status-> ' .  $erp_order_status_def .  ', Woo_order_id-> ' .  $order_id .  ' Woo_order_status-> ' .  $order_status);
				}		

			}	
		}	
								
		Logger::adbxWriteLog('No order updates');

		if (($num_updates == 0) AND ( $synch_type == 0))
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"><p><strong>No order updates</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide</span></button></div>';

		return true;

    }
	
	
	function adbxAlignProducts() { 
		
		$align_array 	= array();
		$align_array	= json_decode($this->erp_json_response, true);
		
		$adbx_num_updates = 0;

		$query_args = array(
			'post_type'  => 'product',
			'post_status' => 'publish',
			'posts_per_page' => -1
		);
				
		$loop = new WP_Query( $query_args ); // Custom Loop 	

		while ($loop->have_posts()) : $loop->the_post();
			
			$still_exists = false;
			$theid = get_the_ID();
			$post_advarics_id = get_post_meta($theid, 'adbx_advarics_articleId', true);
			if ($post_advarics_id)
			{
				foreach ($align_array['articles'] as $item)
				{
					if (isset($item["articleId"]) && $item["articleId"] == $post_advarics_id)
					{
						$still_exists = true;
						continue;
					}
				}
			
				if (!$still_exists)
				{	
					wp_update_post(array(
					'ID'    =>  $theid,
					'post_status'   =>  'draft'
					));
					$messagestring = get_the_title($theid) .  ' no longer present in Advarics webshop, moved to draft status';
					echo '<div class="error"><p>' . $messagestring . '</p></div>';
					Logger::adbxWriteLog( $messagestring);
					$adbx_num_updates++;
				}	
			}	

		endwhile; 
		
		echo '<div class="error"><p>Number of WooCommerce products no longer present in Advarics: ' . $adbx_num_updates . '</p></div>';
				
		return true;

    }
	
	
}

