<?php 
/**
 * @package  WooadvaricsPlugin
 */
defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' ); 
 
require_once ADBX_PLUGIN_PATH . 'inc/wooadvarics-plugin-connect.php';

class AdvaricsSynchOrder extends AdbxERPConnection {
	 
	private $woo_order_id;
	
	private $woo_order;
	
	private $orderNo;
	
	private $customer_id;
	
	private $payment_method;
	
	private $paymentStatus;
	
	public $erp_id;
	
	public function adbxGetWooOrder( $order_id ) {

		$this->woo_order_id 	= $order_id;	
		$this->order 			= new WC_Order( $this->woo_order_id ); // Order Object
		$this->orderNo			= $this->order->get_order_number();
		$this->customer_id 		= $this->order->get_customer_id();
		$this->payment_method	= $this->order->get_payment_method_title();
		$this->paymentStatus	= $this->order->get_status();
		
		return $this->orderNo;
	
	}
	
	public function adbxCreateErpOrder() {
		
		$size_attrib 	= 'attribute_pa_' . get_option('adbx_advarics_size');
		
		$adbx_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
		
		$json_data_array = array();
		
		// Order positions
		$items 	= $this->order->get_items();
		$pos = 0;
		
		foreach ($items as $item) 		
		{	
			$product_id	= $item->get_product_id();
			if (get_post_meta($product_id,'adbx_advarics_articleId', true))
			{
				$product 		= $item->get_product();
				$articleNo		= get_post_meta( $product_id, 'articleNo', true );
				
				
				if( ($product->is_type('simple')) AND ( null !== get_post_meta( $product_id, 'adbx_onedimension_gtin', true )) )
				{
					// a simple product  
					$original_gtin	= get_post_meta( $product_id, 'adbx_onedimension_gtin', true );
					$item_size		= get_post_meta( $product_id, 'adbx_onedimension_size', true );
				} 
				elseif( ($product->is_type( 'variation' )) OR ($product->is_type('simple'))  )
				{
					// a variable product
					$variation_id 	= $item->get_variation_id();
					$variation 		= wc_get_product_variation_attributes($variation_id);
					//$sku 			= $product->get_sku();
					$original_gtin	= get_post_meta( $variation_id, 'adbx_gtin', true );
					$item_size		= strtoupper($variation[$size_attrib]);
				}
				else
				{
					$original_gtin	= 'No GTIN';
					$item_size		= 'No Size';	
				}	
				
				
				//$variation_id 	= $item->get_variation_id();
				//$variation 		= wc_get_product_variation_attributes($variation_id);
				//$sku 			= $product->get_sku();
				//$original_gtin	= get_post_meta( $variation_id, 'adbx_gtin', true );
				$product_qty 	= $item->get_quantity();
				//$total			= $item->get_total();
				$total			= $item->get_subtotal();
				//$tax 			= $item->get_subtotal_tax();
				$tax 			= $item->get_subtotal_tax();
				$sales_price	= round(($total + $tax),2);
				$unit_price		= $sales_price/$product_qty;
				/*
				echo '<br>$total:' . $total;
				echo '<br>$tax:' . $tax;
				echo '<br>$sales_price:' . $sales_price;
				echo '<br>$unit_price:' . $unit_price;
				*/
				
				$this->input_array["orderToInsert"]["positions"][$pos]["positionNo"] = $pos+1;
				$this->input_array["orderToInsert"]["positions"][$pos]["articleNo"] = $articleNo;
				$this->input_array["orderToInsert"]["positions"][$pos]["gtin"] = $original_gtin;
				$this->input_array["orderToInsert"]["positions"][$pos]["size"] =  $item_size;
				$this->input_array["orderToInsert"]["positions"][$pos]["quantity"] = $product_qty;
				//$this->input_array["orderToInsert"]["positions"][$pos]["salesPrice"] = $sales_price;
				$this->input_array["orderToInsert"]["positions"][$pos]["salesPrice"] = $unit_price;
				$this->input_array["orderToInsert"]["positions"][$pos]["regularBooking"] = true;
				$pos++;	
				
			}

		}
		
		if ( ($pos > 0) AND (( $adbx_codice_plugin == 20 ) OR ( $adbx_codice_plugin == 19 )) )
		{ 
			$shipping_costs 	= $this->order->get_shipping_total();
			$shipping_costs_tax = $this->order->get_shipping_tax();
			$shipping_costs_total = round(($shipping_costs + $shipping_costs_tax),2);
			
			if ($shipping_costs_total > 0)
			{		
				$this->input_array["orderToInsert"]["positions"][$pos]["positionNo"] = $pos+1;
				$this->input_array["orderToInsert"]["positions"][$pos]["articleNo"] = 'vkpws' ; //$articleNo;
				$this->input_array["orderToInsert"]["positions"][$pos]["gtin"] = '2000002912491'; //$original_gtin;
				$this->input_array["orderToInsert"]["positions"][$pos]["size"] =  'STUECK'; //$item_size;
				$this->input_array["orderToInsert"]["positions"][$pos]["quantity"] = 1;
				$this->input_array["orderToInsert"]["positions"][$pos]["salesPrice"] = $shipping_costs_total;
				$this->input_array["orderToInsert"]["positions"][$pos]["regularBooking"] = true;
			}
		}	
		
		if ($pos > 0)
		{
			$erp_customer_no = $this->adbxGetERPCustomerNo( $this->customer_id );
			// Parameters
			$orderSource	= ADBX_ORDER_SOURCE;
			$webShopId		= get_option('adbx_advarics_webshopID');
			$webShopName	= get_option('adbx_advarics_webshopName');
			$dispatchType	= ADBX_DISPATCH_TYPE;
			//$order_date 	= date("Y-m-d H:i:s"); 2021-08-23T09:16:53.317Z
			/*date("Y-m-d\TH:i:s.000\Z");
			$order_date		= date("Y-m-d H:i:s",strtotime($this->order->get_date_created()));
			if (! $order_date)
				$order_date 	= date("Y-m-d H:i:s");
			*/
			$order_date	= date("Y-m-d\TH:i:s.000\Z",strtotime($this->order->get_date_created()));
			if (! $order_date)
				$order_date 	= date("Y-m-d\TH:i:s.000\Z");
			
			$this->input_array["identification"]["id"] = $this->erp_id;
			$this->input_array["orderToInsert"]["orderNo"] = $this->orderNo;
			$this->input_array["orderToInsert"]["orderSource"] = $orderSource;
			$this->input_array["orderToInsert"]["webShopId"] = $webShopId;
			$this->input_array["orderToInsert"]["webShopName"] = $webShopName;
			$this->input_array["orderToInsert"]["date"] = $order_date;
			$this->input_array["orderToInsert"]["dispatchType"] = $dispatchType;
			// Payment Method
			//$this->input_array["orderToInsert"]["paymentMethod"] = $this->payment_method;
			$transaction_id = get_post_meta($this->woo_order_id, '_transaction_id', true);
			if ($transaction_id)
				$this->input_array["orderToInsert"]["paymentMethod"] = substr($this->payment_method . '-ID ' . $transaction_id,0,50);
			else 
				$this->input_array["orderToInsert"]["paymentMethod"] = $this->payment_method;
			// Customer Address
			$this->input_array["orderToInsert"]["customerAddress"]["no"] = $erp_customer_no;
			$this->input_array["orderToInsert"]["customerAddress"]["firstname"] = $this->order->get_billing_first_name( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["lastname"] = $this->order->get_billing_last_name( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["street"] = $this->order->get_billing_address_1( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["houseNo"] = '';
			$this->input_array["orderToInsert"]["customerAddress"]["postalCode"] = $this->order->get_billing_postcode( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["city"] = $this->order->get_billing_city( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["country"] = $this->order->get_billing_country( $context = 'view' );
			$this->input_array["orderToInsert"]["customerAddress"]["title"] = '';
			$this->input_array["orderToInsert"]["customerAddress"]["salutation"] = '';
			// Delivery Address
			$this->input_array["orderToInsert"]["customerAddress"]["deliveryStreet"] = $this->order->get_shipping_address_1($context = 'view') ? $this->order->get_shipping_address_1($context = 'view') : '';
			$this->input_array["orderToInsert"]["customerAddress"]["deliveryHouseNo"] = '';
			$this->input_array["orderToInsert"]["customerAddress"]["deliveryPostalCode"] = $this->order->get_shipping_postcode($context = 'view') ? $this->order->get_shipping_postcode($context = 'view') : '';
			$this->input_array["orderToInsert"]["customerAddress"]["deliveryCity"] = $this->order->get_shipping_city($context = 'view') ? $this->order->get_shipping_city($context = 'view') : '';
			$this->input_array["orderToInsert"]["customerAddress"]["deliveryCountry"] = $this->order->get_shipping_country($context = 'view') ? $this->order->get_shipping_country($context = 'view') : '';
			// Customer Info
			$this->input_array["orderToInsert"]["customerInfo"]["noOfOrders"] = 0;
			$this->input_array["orderToInsert"]["customerInfo"]["salesSum"] = 0;
			$this->input_array["orderToInsert"]["customerInfo"]["returnsQuotaRegardingQuantity"] = 0;
			$this->input_array["orderToInsert"]["customerInfo"]["returnsQuotaRegardingAmount"] = 0;
			// Payment status
			$this->input_array["orderToInsert"]["paymentStatus"] = $this->paymentStatus;
			$this->input_array["orderToInsert"]["totalDiscountSP"] = $this->order->get_discount_tax() + $this->order->get_discount_total();
			// Customer additional data
			$this->input_array["orderToInsert"]["customerAdditionalData"]["customerFonPrivate1"] = $this->order->get_billing_phone($context = 'view') ? $this->order->get_billing_phone($context = 'view') : '';
			$this->input_array["orderToInsert"]["customerAdditionalData"]["customerEmail"] = $this->order->get_billing_email($context = 'view') ? $this->order->get_billing_email($context = 'view') : '';
	
			$order_to_sent_json = json_encode( $this->input_array, JSON_UNESCAPED_UNICODE );
			
			$synch_instance 	= new AdbxSynchWooAdvarics();
			$erp_response		= $synch_instance->adbxSendOrderERP( $order_to_sent_json );
			
			//$erp_response = '{"orderId":296,"ok":true,"errorMessage":"","customerResponses":[]}';
			//$erp_response = '{"orderId":-1,"ok":false,"errorMessage":"Cannot insert Order: Order exists already with different positions!","customerResponses":null}';
			//Logger::adbxWriteLog( $order_to_sent_json);
						
			$json_data_array 	= json_decode($erp_response, true); //ARRAY	

		}
		else
		{
			update_post_meta( $this->orderNo , 'adbx_sent_to_erp', 4);
			$json_data_array["success"] = 'false';
			$json_data_array["message"] = 'Error in syncronizaztion of Webshop Order nr:' . $this->orderNo . ' -> no activ Advarics product in order!';
		}	
		
		// ERP Message response
		if (array_key_exists( 'ok',  $json_data_array)) 
		{
			if ( $json_data_array["ok"] == true )
			{
				// Order registered in Advarics
				$erp_orderid = $json_data_array["orderId"];
				update_post_meta( $this->orderNo , 'erp_orderid', $erp_orderid);
				//update_post_meta( $this->orderNo , 'adbx_sent_to_erp', 'yes');
				update_post_meta( $this->orderNo , 'adbx_sent_to_erp', 1);
				update_post_meta( $this->orderNo , 'adbx_erp_customer_no', $erp_customer_no);
				
				if (array_key_exists( 'customerResponses',  $json_data_array)) 
				{
					if ( count($json_data_array["customerResponses"]) > 0) 
					{
						if ( $json_data_array["customerResponses"]["0"]["imported"] == true )
						{
							$message = 'New Advarics order nr:' . $erp_orderid . ' registered for Webshop Order nr:' . $this->orderNo . ', Erp_customer_no: ' . $erp_customer_no;
						}	
						else
						{
							$message = 'New Advarics order nr:' . $erp_orderid . ' registered for Webshop Order nr:' . $this->orderNo . ', with Warning in customer registration in Advarics for Erp_customer_no: ' . $erp_customer_no;
						}
					}	
					else
					{
						$message = 'New Advarics order nr:' . $erp_orderid . ' registered for Webshop Order nr:' . $this->orderNo . ', without Customer Registration in Advarics for Erp_customer_no: ' . $erp_customer_no;
					}
				}
				else
				{
					$message = 'New Webshop Order nr:' . $this->orderNo . ' registered with warnings in Advarics';
				}
				
				$response = '{"success": true,"message": "' . $message . '"}';
			}
			else
			{
				if ( (array_key_exists( 'orderId',  $json_data_array)) AND (array_key_exists( 'errorMessage',  $json_data_array)) )
				{
					if ( ( $json_data_array["orderId"] == '-1' ) AND ( $json_data_array["errorMessage"] == 'Cannot insert Order: Order exists already with different positions!' ) )
					{
						update_post_meta( $this->orderNo , 'adbx_sent_to_erp', 1);
						$message = 'Warning: cannot insert Order in Advarics as order already exists with different positions!';	
					}
					else
						$message = 'Error (903) registering Webshop Order nr:' . $this->orderNo . ' in Advarics';
				}
				else
					$message = 'Error (904) registering Webshop Order nr:' . $this->orderNo . ' in Advarics';	
				
				$response = '{"success": false,"message": "' . $message . '"}';
			}
		}
		elseif (array_key_exists( 'StatusCode',  $json_data_array))  // Internal server Error
		{
			if (array_key_exists( 'Message',  $json_data_array)) 
				$response = '{"success": false,"message": "' . $json_data_array["Message"] . '"}';
			elseif (array_key_exists( 'message',  $json_data_array)) 
				$response = '{"success": false,"message": "' . $json_data_array["message"] . '"}';
			else
			{
				$message = 'Error ' . $json_data_array["StatusCode"] . ' registering Webshop Order nr:' . $this->orderNo . ' in Advarics';
				$response = '{"success": false,"message": "' . $message . '"}';
			}
			
		}
		elseif (array_key_exists( 'success',  $json_data_array)) // Success Error 901
		{	
			if (array_key_exists( 'message',  $json_data_array)) 
				$response = '{"success": false,"message": "' . $json_data_array["message"] . '"}';
			else
				$response = '{"success": false,"message": "ERROR 901"}';
		}
		else //generic error  902
		{	
			$response = '{"success": false,"message": "ERROR 902"}';
		}
		

			
		$this->result = $response;

		return $this->result;
	}

		
		
	private function adbxGetERPCustomerNo( $user_id)
	{
	
		$customer_no = get_user_meta( $user_id, 'erp_customer_no' , true );
		if ($customer_no > 0) 
			return $customer_no;
		else 
		{
			
			$next_erp_customer_num 	= get_option( 'adbx_next_erp_customer_num' );
			
			if ( $next_erp_customer_num ) 
			{	
				$customer_no = $next_erp_customer_num;
				$next_erp_customer_num++;
				
				if ($user_id === 0 )  
					update_option( 'adbx_next_erp_customer_num', $next_erp_customer_num );
				else 
				{
					update_option( 'adbx_next_erp_customer_num', $next_erp_customer_num );
					update_user_meta( $user_id, "erp_customer_no", $customer_no );	// New registered customer	
				}
				
				return ( $customer_no );
			}	
			else 
			{	
				return null;
			}	
			
		}	

	}
	
	
	public function adbxCancelOrder( $order ) {
			
		$erp_orderid = get_post_meta(  $order->get_id() , 'erp_orderid', true );
		$json_array = array();
		$json_array["identification"]["id"] = $this->erp_id;
		$json_array["orderId"] = $erp_orderid;
		$order_to_sent_json = json_encode( $json_array );
		
		$synch_instance 	= new AdbxSynchWooAdvarics();
		$erp_response		= $synch_instance->adbxCancelERPOrder( $order_to_sent_json, 'CancelOrder' ); 

		//Logger::adbxWriteLog( $order_to_sent_json );
		//$erp_response = '{"ok":true,"errorMessage":""}';
		
		$json_data_array 	= json_decode($erp_response, true);
		
		// ERP Message response
		if (array_key_exists( 'ok',  $json_data_array)) 
		{
			if ( $json_data_array["ok"] == true )
			{
				//$order->update_status( 'cancelled' );
				update_post_meta( $order->get_id() , 'adbx_sent_to_erp', 2); //storno ordine completo
				$message = 'Order cancelled in Advarics:' . $order->get_order_number();
				$response = '{"success": true,"message": "' . $message . '"}';
			}
			else
			{
				$message = 'Error cancelling order in Advarics:' . $order->get_order_number();
				$response = '{"success": false,"message": "' . $message . '"}';
			}
		}
		else
		{
			$message = 'Error 404 in CancelOrder - Ordernr:' . $order->get_order_number();
			$response = '{"success": false,"message": "' . $message . '"}';
		}	
		
		return $response;
	}	
	
	
	public function adbxCancelOrderPosition( $order, $position ) {
			
		$erp_orderid = get_post_meta(  $order->get_id() , 'erp_orderid', true ); 
		$json_array = array();
		$json_array["identification"]["id"] = $this->erp_id;
		$json_array["orderId"] = $erp_orderid;
		$json_array["positionNo"] = $position;
		$order_to_sent_json = json_encode( $json_array );
		
		$synch_instance = new AdbxSynchWooAdvarics();
		$erp_response	= $synch_instance->adbxCancelERPOrder( $order_to_sent_json, 'CancelOrderPosition' ); 

		//Logger::adbxWriteLog( $order_to_sent_json );
		//$erp_response = '{"ok":true,"errorMessage":""}';
		
		$json_data_array = json_decode($erp_response, true);
		
		// ERP Message response
		if (array_key_exists( 'ok',  $json_data_array)) 
		{
			if ( $json_data_array["ok"] == true )
			{
				update_post_meta( $order->get_id() , 'adbx_sent_to_erp', 3); //stornato parzialmente
				$message = 'Order position: ' .  $position . ' cancelled in Advarics:' . $order->get_order_number();
				$response = '{"success": true,"message": "' . $message . '"}';
			}
			else
			{
				$message = 'Error cancelling order position: ' . $position . ' in Advarics:' . $order->get_order_number();
				$response = '{"success": false,"message": "' . $message . '"}';
			}
		}
		else
		{
			$message = 'Error 405 in CancelOrderPosition for position: ' . $position . ', Ordernr:' . $order->get_order_number();
			$response = '{"success": false,"message": "' . $message . '"}';
		}	
		
		
		return $response;
	}
	
}	

 


