<?php 
/**
 * @package  WooadvaricsPlugin
 */
defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' );

class WooAdvaricsSettingsApi
{

	public $settings = array();

	public $sections = array();

	public $fields = array();
	
	public $wooadvarics_title_fields = array();
	
	
	function __construct() {

		$this->wooadvarics_title_fields = array("","articleNo","articleName","brand","inhouseColorNo","inhouseColorName","supplierColorNo", "supplierColorName","webshopArticleNo");

		add_action( 'admin_menu', array( $this, 'addAdminMenu' ) );

		add_filter( 'plugin_action_links_' . ADBX_PLUGIN, array( $this, 'settingsLink' ) );

	}
	
	public function addAdminMenu() {
		
		$value_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
		
		add_menu_page( 'WooAdvarics Plugin', 'WooAdvarics', 'manage_options', 'wooadvarics_plugin',array( $this, 'wooadvarics_adminIndex' ), 'dashicons-controls-repeat', 110 );
		
		add_submenu_page('wooadvarics_plugin', 'WooAdvarics Submenu 1', 'Adiabax License', 'manage_options', 'wooadvarics_plugin2', array( $this, 'wooadvarics_adminIndex_sub1' ), 111 );
	
		add_submenu_page('wooadvarics_plugin', 'WooAdvarics Submenu 2', 'Extra Attributes', 'manage_options', 'wooadvarics_plugin3', array( $this, 'wooadvarics_adminIndex_sub2' ), 112 );

		if (($value_codice_plugin == 19) OR ( $value_codice_plugin == 50))
			add_submenu_page('wooadvarics_plugin', 'WooAdvarics Submenu 4', 'Extra Texts', 'manage_options', 'wooadvarics_plugin4', array( $this, 'wooadvarics_adminIndex_sub4' ), 112 );

	}
	

	public function wooadvarics_adminIndex() {
		require_once ADBX_PLUGIN_PATH . 'templates/admin.php';
		}
		
	public function wooadvarics_adminIndex_sub1() {
		require_once ADBX_PLUGIN_PATH . 'templates/admin_submenu_1.php';
		}
		
	public function wooadvarics_adminIndex_sub2() {
		require_once ADBX_PLUGIN_PATH . 'templates/admin_extra_attributes.php';
		}	
		
	public function wooadvarics_adminIndex_sub4() {
		require_once ADBX_PLUGIN_PATH . 'templates/admin_extra_texts.php';
		}	
		
	
	public function settingsLink( $links ) {
		$settingsLink = '<a href="admin.php?page=wooadvarics_plugin">Settings</a>';
		array_push( $links, $settingsLink );
		return $links;
	}
	
	
	public function register() {
	
		$this->setSettings();
		$this->setSections();
		$this->setFields();
		
		if ( !empty($this->settings) ) {
			add_action( 'admin_init', array( $this, 'registerCustomFields' ) );
		}
	}	
	
	
	public function setSettings()
	{
		$args = array(
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_id'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_api_url'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_webshopID'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_webshopName'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_next_erp_customer_num',
				'callback' => array( $this, 'wooadvaricsOptionsGroup' )
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_new_product_status'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_synch_configuration'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advaricsProductTitle_1'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advaricsProductTitle_2'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advaricsProductTitle_3'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advaricsProductExcerpt'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_new_product_content'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_product_category'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_img_gallery'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_webshop_order_destination'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_webshop_order_to_email'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_webshopsynch'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_log'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_size'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_color'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_color2'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_gtin'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_gtin_meta_field'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_brand'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_changedat_synch'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_variation_id'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_productlist_synch'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_single_item_ID'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_extra_attributes'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_article_texts'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_product_sku_code'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_synchprocess'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_img_name'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_block_size'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_advarics_changedAt'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_simple_product'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_price_update'
			),
			array(
				'option_group' => 'wooadvarics_options_group',
				'option_name' => 'adbx_outofstock_variant'
			)
			
			
			
		);

		$this->settings = $args;
	}
	
	
	public function setSections()
	{
		$args = array(
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex',
				'title' => esc_html__('Settings','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsAdminSection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex2',
				//'title' => 'Product',
				'title' => esc_html__('Product','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsProdcutSection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex8',
				//'title' => 'Size and Color Attributes',
				'title' => esc_html__('Size and Color Attributes','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsAttributeSection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex9',
				//'title' => 'Extra/Other Attributes',
				'title' => esc_html__('Extra/Other Attributes','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsExtraAttributeSection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex3',
				//'title' => 'Product Category',
				'title' => esc_html__('Product Category','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsCategorySection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex4',
				//'title' => 'Product Images',
				'title' => esc_html__('Product Images','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsThumbnailSection' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex10',
				//'title' => 'Article Texts',
				'title' => esc_html__('Article Texts','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsArticleTexts' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex5',
				//'title' => 'WebShop Orders',
				'title' => esc_html__('WebShop Orders','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsWebShopOrders' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex6',
				//'title' => 'WebShop synchronization',
				'title' => esc_html__('WebShop synchronization','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsWebShopSyncronization' ),
				'page' => 'wooadvarics_plugin'
			),
			array(
				'id' => 'wooadvarics_wooadvarics_adminIndex7',
				//'title' => 'Synchronization Log',
				'title' => esc_html__('Synchronization Log','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsSynchronizationLog' ),
				'page' => 'wooadvarics_plugin'
			)
			
		);

		$this->sections = $args;
	}

	
	public function setFields()
	{
		$args = array(
			array(
				'id' => 'adbx_advarics_id',
				'title' => 'Advarics Service-Id',
				'callback' => array( $this, 'wooadvaricsID' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex',
				'args' => array(
					'label_for' => 'adbx_advarics_id',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advarics_api_url',
				'title' => 'Advarics API URL',
				'callback' => array( $this, 'wooadvaricsAPIURL' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex',
				'args' => array(
					'label_for' => 'adbx_advarics_api_url',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advarics_webshopID',
				'title' => 'Advarics Webshop-ID',
				'callback' => array( $this, 'wooadvaricsWebshopID' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex',
				'args' => array(
					'label_for' => 'adbx_advarics_webshopID',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advarics_webshopName',
				'title' => 'Advarics Webshop-Filiale',
				'callback' => array( $this, 'wooadvaricsWebshopName' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex',
				'args' => array(
					'label_for' => 'adbx_advarics_webshopName',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_next_erp_customer_num',
				//'title' => 'Advarics Next Webshop customer number',
				'title' => esc_html__('Advarics Next Webshop customer number','wooadvarics-plugin'),
				'callback' => array( $this, 'wooadvaricsErpNextCn' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex',
				'args' => array(
					'label_for' => 'adbx_next_erp_customer_num',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_new_product_status', 
				//'title' => 'Status of new loaded product', 
				'title' => esc_html__('Status of new loaded product','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductStatus' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex', 
				'args' => array(
					'label_for' => 'adbx_new_product_status', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_synch_configuration', 
				//'title' => 'Synchronization mode for Title, Excerpt and Content', 
				'title' => esc_html__('Synchronization mode for Title, Excerpt and Content','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsSyncronizationMode' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex', 
				'args' => array(
					'label_for' => 'adbx_synch_configuration', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advaricsProductTitle_1', 
				//'title' => 'Title', 
				'title' => esc_html__('Title','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductTitle1' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advaricsProductTitle_1', 
					'class' => 'adbx-titleinput-class'
				)
			),
			array(
				'id' => 'adbx_advaricsProductTitle_2', 
				'title' => '', 
				'callback' => array( $this, 'advaricsProductTitle2',  ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advaricsProductTitle_2', 
					'class' => 'dbx-titleinput-class'
				)
			),
			array(
				'id' => 'adbx_advaricsProductTitle_3', 
				'title' => '', 
				'callback' => array( $this, 'advaricsProductTitle3',  ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advaricsProductTitle_3', 
					'class' => 'dbx-titleinput-class'
				)
			),
			array(
				'id' => 'adbx_advaricsProductExcerpt',
				//'title' => 'Excerpt/Short description',
				'title' => esc_html__('Excerpt/Short description','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductExcerpt' ),
				'page' => 'wooadvarics_plugin',
				'section' => 'wooadvarics_wooadvarics_adminIndex2',
				'args' => array(
					'label_for' => 'adbx_advaricsProductExcerpt',
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_new_product_content', 
				//'title' => 'Product content/Long description', 
				'title' => esc_html__('Product content/Long description','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductContent' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_new_product_content', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_product_category', 
				//'title' => 'Main and sub categories', 
				'title' => esc_html__('Main and sub categories','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductCategory' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex3', 
				'args' => array(
					'label_for' => 'adbx_product_category', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_img_gallery', 
				//'title' => 'Product Image Gallery', 
				'title' => esc_html__('Product Image Gallery','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsImageGallery' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex4', 
				'args' => array(
					'label_for' => 'adbx_img_gallery', 
					'class' => 'adbx-generic-class'
				)	
			),
			array(
				'id' => 'adbx_img_name', 
				//'title' => 'Product Image Gallery', 
				'title' => esc_html__('Product Image Name','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsImageName' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex4', 
				'args' => array(
					'label_for' => 'adbx_img_name', 
					'class' => 'adbx-generic-class'
				)	
			),
			array(
				'id' => 'adbx_webshop_order_destination', 
				//'title' => 'Order propagation', 
				'title' => esc_html__('Order propagation','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsOrderDestination' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex5', 
				'args' => array(
					'label_for' => 'adbx_webshop_order_destination', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_webshopsynch', 
				//'title' => 'Synchronization schedule', 
				'title' => esc_html__('Synchronization schedule','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsWebShopSynch' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex6', 
				'args' => array(
					'label_for' => 'adbx_advarics_webshopsynch', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_log', 
				//'title' => 'Event logging', 
				'title' => esc_html__('Event logging','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsynchLog' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex7', 
				'args' => array(
					'label_for' => 'adbx_advarics_log', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_size', 
				//'title' => 'Size Attribute', 
				'title' => esc_html__('Size Attribute','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricSizeAttribute' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex8', 
				'args' => array(
					'label_for' => 'adbx_advarics_size', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_color', 
				//'title' => 'Color Attribute', 
				'title' => esc_html__('Color Attribute 1 - inhouse color name','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricColorAttribute' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex8', 
				'args' => array(
					'label_for' => 'adbx_advarics_color', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_color2', 
				//'title' => 'Color Attribute', 
				'title' => esc_html__('Color Attribute 2 - supplier color name','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricColorAttribute2' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex8', 
				'args' => array(
					'label_for' => 'adbx_advarics_color2', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_simple_product', 
				//'title' => 'Product ID/SKU', 
				'title' => esc_html__('Product Type','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductType' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_simple_product', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_outofstock_variant', 
				//'title' => 'Product ID/SKU', 
				'title' => esc_html__('Out of Stock Product/Variants','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsOutofstockVariant' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_outofstock_variant', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_price_update', 
				//'title' => 'Product ID/SKU', 
				'title' => esc_html__('Product/Variant Prices','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductPrices' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_price_update', 
					'class' => 'adbx-generic-class'
				)
			),				
			array(
				'id' => 'adbx_product_sku_code', 
				//'title' => 'Product ID/SKU', 
				'title' => esc_html__('Product ID/SKU','wooadvarics-plugin'),
				'callback' => array( $this, 'advaricsProductSKU' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_product_sku_code', 
					'class' => 'adbx-generic-class'
				)
			),	

			array(
				'id' => 'adbx_advarics_variation_id', 
				//'title' => 'Product variation ID',
				'title' => esc_html__('Product variation ID','wooadvarics-plugin'),				
				'callback' => array( $this, 'advaricsVariationID' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advarics_variation_id', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_gtin', 
				//'title' => 'GTIN', 
				'title' => esc_html__('GTIN','wooadvarics-plugin'),	
				'callback' => array( $this, 'advaricsGTIN' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advarics_gtin', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advarics_brand', 
				//'title' => 'Brand', 
				'title' => esc_html__('Brand','wooadvarics-plugin'),	
				'callback' => array( $this, 'advaricsBrand' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex2', 
				'args' => array(
					'label_for' => 'adbx_advarics_brand', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_changedat_synch', 
				//'title' => 'Synchronization method', 
				'title' => esc_html__('Synchronization method','wooadvarics-plugin'),	
				'callback' => array( $this, 'advaricsWooSynchMethod' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex6', 
				'args' => array(
					'label_for' => 'adbx_advarics_changedat_synch', 
					'class' => 'adbx-generic-class'
				)
			),
			array(
				'id' => 'adbx_advarics_synchprocess', 
				//'title' => 'Synchronization method', 
				'title' => esc_html__('Synchronization process','wooadvarics-plugin'),	
				'callback' => array( $this, 'advaricsWooSynchProcess' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex6', 
				'args' => array(
					'label_for' => 'adbx_advarics_synchprocess', 
					'class' => 'adbx-generic-class'
				)
			),				
			array(
				'id' => 'adbx_advarics_productlist_synch', 
				//'title' => 'Product to synchronize',
				'title' => esc_html__('Product to synchronize','wooadvarics-plugin'),					
				'callback' => array( $this, 'advaricsProductListSynch' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex6', 
				'args' => array(
					'label_for' => 'adbx_advarics_productlist_synch', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_extra_attributes', 
				//'title' => 'Import extra attributes', 
				'title' => esc_html__('Import extra attributes','wooadvarics-plugin'),	
				'callback' => array( $this, 'advaricExtraAttributes' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex9', 
				'args' => array(
					'label_for' => 'adbx_advarics_extra_attributes	', 
					'class' => 'adbx-generic-class'
				)
			),	
			array(
				'id' => 'adbx_advarics_article_texts', 
				//'title' => 'Import article texts',
				'title' => esc_html__('Import article texts','wooadvarics-plugin'),				
				'callback' => array( $this, 'advaricArticleTexts' ), 
				'page' => 'wooadvarics_plugin', 
				'section' => 'wooadvarics_wooadvarics_adminIndex10', 
				'args' => array(
					'label_for' => 'adbx_advarics_article_texts	', 
					'class' => 'adbx-generic-class'
				)
			)				
		);

		$this->fields = $args;
	}

	
	public function registerCustomFields()
	{
		
		foreach ( $this->settings as $setting ) {
			register_setting( $setting["option_group"], $setting["option_name"], ( isset( $setting["callback"] ) ? $setting["callback"] : '' ) );
		}

		foreach ( $this->sections as $section ) {
			add_settings_section( $section["id"], $section["title"], ( isset( $section["callback"] ) ? $section["callback"] : '' ), $section["page"] );
		}

		foreach ( $this->fields as $field ) {
			add_settings_field( $field["id"], $field["title"], ( isset( $field["callback"] ) ? $field["callback"] : '' ), $field["page"], $field["section"], ( isset( $field["args"] ) ? $field["args"] : '' ) );
		}
	}
	
	
		
	public function wooadvaricsOptionsGroup( $input )
	{
		return $input;
	}
	
	public function wooadvaricsAdminSection()
	{
		_e('Change your setting and save the configuration!','wooadvarics-plugin');
	}
	
	public function wooadvaricsProdcutSection()
	{
		_e('Change your product setting and save the configuration!','wooadvarics-plugin');
	}
	
	public function wooadvaricsCategorySection()
	{
		_e('Change your category setting and save the configuration!','wooadvarics-plugin');
	}
	
	public function wooadvaricsThumbnailSection()
	{
		_e('Change your picture gallery setting and save the configuration!','wooadvarics-plugin');
	}
	
	public function wooadvaricsArticleTexts()
	{
		_e('Choose if article texts should be synchronized','wooadvarics-plugin');
	}
	
	public function wooadvaricsWebShopSyncronization()
	{
		_e('Choose Advarics -> WebShop synchronization  interval and the synchronization  method!','wooadvarics-plugin');
	}
	
	public function wooadvaricsWebShopOrders()
	{
		_e('Choose webshop orders destination and save the configuration!','wooadvarics-plugin');
	}
	
	public function wooadvaricsSynchronizationLog()
	{
		_e('Choose if synchronization  events have to be logged!','wooadvarics-plugin');
	}
	
	public function wooadvaricsAttributeSection()
	{
		_e('Choose your size and color attributes. IMPORTANT: If not yet present please create new once before synchronizing!','wooadvarics-plugin');
	}
	
	public function wooadvaricsExtraAttributeSection()
	{
		//echo 'Choose if extra attributes should be synchronized. IMPORTANT: If yes use setting page <a href="admin.php?page=wooadvarics_plugin3">Extra Attributes</a> to configure attributes!';
		_e('Choose if extra attributes should be synchronized. IMPORTANT: If yes, use the setting page','wooadvarics-plugin');
		echo ' <a href="admin.php?page=wooadvarics_plugin3">Extra Attributes</a> ';
		_e('to configure attributes!','wooadvarics-plugin');
	}
	
	
	public function wooadvaricsAdbxLicenseKey()
	{
		$value = esc_attr( get_option( 'adbx_license_key' ) );
		if ( ($value == '') OR ( is_null($value)) )
			echo '<b>WARNINGs</b>: No license has been activated!';
		else
			echo $value;
	}

	
	public function wooadvaricsID()
	{
		$value = esc_attr( get_option( 'adbx_advarics_id' ) );
		echo '<input type="text" class="regular-text" name="adbx_advarics_id" value="' . $value . '" placeholder="Write your Advarics ID">';
	}
	
	public function wooadvaricsAPIURL()
	{
		$value = esc_attr( get_option( 'adbx_advarics_api_url' ) );
		echo '<input type="text" class="regular-text" name="adbx_advarics_api_url" value="' . $value . '" placeholder="Write your API URL"> <i><b>Example:</b> https://yourshop.advarics.net/external/WebShop/</i>';
	}
	
	public function wooadvaricsWebshopID()
	{
		$value = esc_attr( get_option( 'adbx_advarics_webshopID' ) );
		echo '<input type="text" class="regular-text" name="adbx_advarics_webshopID" value="' . $value . '" placeholder="Write your Advarics Webshop-ID">';
	
	}
	
	public function wooadvaricsWebshopName()
	{
		$value = esc_attr( get_option( 'adbx_advarics_webshopName' ) );
		echo '<input type="text" class="regular-text" name="adbx_advarics_webshopName" value="' . $value . '" placeholder="Write your Advarics Webshop-Filale">';
	
	}
	
	
	
	public function wooadvaricsErpNextCn()
	{
		$value = esc_attr( get_option( 'adbx_next_erp_customer_num' ) );
		echo '<input type="number" name="adbx_next_erp_customer_num" value=' . $value . '>';
	}
	
	
	function advaricsProductStatus()
	{
	   ?>
			<input type="radio" name="adbx_new_product_status" value="1" <?php checked(1, get_option('adbx_new_product_status'), true); ?> ><?php _e('draft','wooadvarics-plugin'); ?>
			<input type="radio" name="adbx_new_product_status" value="2" <?php checked(2, get_option('adbx_new_product_status'), true); ?> ><?php _e('publish','wooadvarics-plugin'); ?>
	   <?php
	}
	
	function advaricsSyncronizationMode()
	{
	   ?>
			<input type="radio" name="adbx_synch_configuration" value="1" <?php checked(1, get_option('adbx_synch_configuration'), true); ?> ><?php _e('Synchronize exclusively on product creation','wooadvarics-plugin'); ?>
			<input type="radio" name="adbx_synch_configuration" value="2" <?php checked(2, get_option('adbx_synch_configuration'), true); ?> ><?php _e('Synchronize always (Advarics master)','wooadvarics-plugin'); ?>
	   <?php
	}
	
	function advaricsProductContent()
	{
	   ?>
			<input type="radio" name="adbx_new_product_content" value="1" <?php checked(1, get_option('adbx_new_product_content'), true); ?> ><?php _e('Synch from Advarics','wooadvarics-plugin'); ?>
			<input type="radio" name="adbx_new_product_content" value="2" <?php checked(2, get_option('adbx_new_product_content'), true); ?> ><?php _e('Blanc (filled in Woocommerce)','wooadvarics-plugin'); ?>
	   <?php
	}
	
	
	function advaricsProductTitle1(  ) 
	{ 
		
		$options = get_option( 'adbx_advaricsProductTitle_1' );
		?>
		
		<select name='adbx_advaricsProductTitle_1'>
		<?php
		$i = 1;
		foreach($this->wooadvarics_title_fields as $item) {
			echo '<option value='. $i . ' ' . selected( $options, $i ) . '>' . $this->wooadvarics_title_fields[$i-1] . '</option>';
			$i++;
		}
		?>	
		</select> 

		<?php
		_e('Product title composed of the concatenation of single items. Example brand - articleName - articleNo','wooadvarics-plugin');
	}
	
	function advaricsProductTitle2(  ) { 
		
		$options = get_option( 'adbx_advaricsProductTitle_2' );
		
		?>
		<select name='adbx_advaricsProductTitle_2'>
		<?php
		$i = 1;
		foreach($this->wooadvarics_title_fields as $item) {
			echo '<option value='. $i . ' ' . selected( $options, $i ) . '>' . $this->wooadvarics_title_fields[$i-1] . '</option>';
			$i++;
		}

		?>	
		</select>
	<?php
	}
	
	function advaricsProductTitle3(  ) { 
		
		$options = get_option( 'adbx_advaricsProductTitle_3' );
		?>
		
		<select name='adbx_advaricsProductTitle_3'>
		<?php
		$i = 1;
		foreach($this->wooadvarics_title_fields as $item) {
			echo '<option value='. $i . ' ' . selected( $options, $i ) . '>' . $this->wooadvarics_title_fields[$i-1] . '</option>';
			$i++;
		}
		echo '</select>';

	}
	
	public function advaricsProductExcerpt()
	{

		$value = esc_attr( get_option( 'adbx_advaricsProductExcerpt' ) );
		echo '<textarea rows="4" cols="100" id="product_excerpt" name="adbx_advaricsProductExcerpt" >' . $value . '</textarea>';
		?>
		<br><br>
		<?php
		foreach($this->wooadvarics_title_fields as $item) {
			if ( $item <> '') {
			?>
			<button id="<?php echo $item; ?>" type="button" class="button" onclick=writeItem(this)><?php echo $item; ?></button>
			<?php
			}
		}
		echo '<br><br>';
		_e(' Use buttons to add/remove single items; use clear text and HTML tags to format the output.','wooadvarics-plugin');
		echo '<br><b>Example:</b><br>Codex:%articleNo%<br>Color:%inhouseColorName%<br>Brand:&ltb&gt&ltu&gt%brand%&lt/u&gt&lt/b&gt ';	
	}
	
	function advaricsProductCategory()
	{
		$value = esc_attr( get_option( 'adbx_codice_plugin' ) );

		?>
			
			<input type="radio" name="adbx_product_category" value="1" <?php checked(1, get_option('adbx_product_category'), true); ?> ><?php _e('One single category ( goodsGroupName - Warengruppe Name)','wooadvarics-plugin'); ?> 
			<br><input type="radio" name="adbx_product_category" value="2" <?php checked(2, get_option('adbx_product_category'), true); ?> ><?php _e('Advarics WebShop categories ( WebShop-Kategorie 1, WebShop-Kategorie 2, WebShop-Kategorie 3)','wooadvarics-plugin'); ?> 
			<br><input type="radio" name="adbx_product_category" value="5" <?php checked(5, get_option('adbx_product_category'), true); ?> ><?php _e('Advarics WebShop categories imported only during product creation - no further synchronization ','wooadvarics-plugin'); ?> 
			<br><input type="radio" name="adbx_product_category" value="7" <?php checked(7, get_option('adbx_product_category'), true); ?> ><?php _e('Category tree divided by "|", use WebShopCategory1 field to insert the values. Example: WOMAN | OUTDOOR | TREKKING | JACKETS','wooadvarics-plugin'); ?> 
			<br><input type="radio" name="adbx_product_category" value="4" <?php checked(4, get_option('adbx_product_category'), true); ?> ><?php _e('Categories managed directly in WooCommerce - No synch','wooadvarics-plugin'); ?> 
			<?php 
			if (( $value == 10) OR ($value > 999990) OR ($value == 19)){
			?>
				<br><input type="radio" name="adbx_product_category" value="3" <?php checked(3, get_option('adbx_product_category'), true); ?> ><?php _e('Pizblanc custom category settings','wooadvarics-plugin'); ?> 
			<?php
			}
			if (( $value == 19) OR ($value == 30)){
			?>
				<br><input type="radio" name="adbx_product_category" value="6" <?php checked(6, get_option('adbx_product_category'), true); ?> ><?php _e('Permalink Manager custom settings','wooadvarics-plugin'); ?> 
			<?php
			}
	}
	
	function advaricsImageGallery()
	{
	   ?>
			<input type="radio" name="adbx_img_gallery" value="1" <?php checked(1, get_option('adbx_img_gallery'), true); ?> ><?php _e('Synchronized with Advarics - original image + image sub-sizes','wooadvarics-plugin'); ?>
			<br><input type="radio" name="adbx_img_gallery" value="3" <?php checked(3, get_option('adbx_img_gallery'), true); ?> ><?php _e('Synchronized with Advarics - only original image (recommended for initial load or large images) **','wooadvarics-plugin'); ?>
			<br><input type="radio" name="adbx_img_gallery" value="4" <?php checked(4, get_option('adbx_img_gallery'), true); ?> ><?php _e('Synchronized with Advarics only on product creation','wooadvarics-plugin'); ?>
			<br><input type="radio" name="adbx_img_gallery" value="2" <?php checked(2, get_option('adbx_img_gallery'), true); ?> ><?php _e('No pics synchronization  (added in Woocommerce)','wooadvarics-plugin'); ?>

	 <?php
			echo '<p style="color:red">';
			_e('** Images sub-sizes can be generated later without interfering with the product creation ','wooadvarics-plugin');
			echo '</p>';
	}
	
	function advaricsImageName()
	{
		$value_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
		?>
		<input type="radio" name="adbx_img_name" value="1" <?php checked(1, get_option('adbx_img_name'), true); ?> ><?php _e('Advarics filename','wooadvarics-plugin'); ?>
		<input type="radio" name="adbx_img_name" value="2" <?php checked(2, get_option('adbx_img_name'), true); ?> ><?php _e('Brand-ArticleName-SupplierColorName','wooadvarics-plugin'); ?>
		<?php 
		if ( ($value_codice_plugin == 19) OR ($value_codice_plugin == 30) )
		{	
		?><input type="radio" name="adbx_img_name" value="3" <?php checked(3, get_option('adbx_img_name'), true); ?> ><?php _e('Brand-ArticleName-SupplierColorName-articleNo','wooadvarics-plugin');?>
		<?php 
		}
		if ( ($value_codice_plugin == 30) OR ($value_codice_plugin == 124))
		{	
		?><input type="radio" name="adbx_img_name" value="4" <?php checked(4, get_option('adbx_img_name'), true); ?> ><?php _e('Brand-ArticleName-SupplierColorName-articleId','wooadvarics-plugin');?>
		<?php 
		}
		?>		
 
	  <?php
	}
	
	
	function advaricsOrderDestination()
	{
	   ?>
			<input type="radio" name="adbx_webshop_order_destination" value="1" <?php checked(1, get_option('adbx_webshop_order_destination'), true); ?>><?php _e('Send order to Advarics in real time','wooadvarics-plugin'); ?> 
			<input type="radio" name="adbx_webshop_order_destination" value="2" <?php checked(2, get_option('adbx_webshop_order_destination'), true); ?>><?php _e('Order stops on the webshop (can be manually submitted later)','wooadvarics-plugin'); ?> 
	   <?php
	}
	
	
	function advaricsWebShopSynch()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_webshopsynch' ) );
	   $every_minutes = esc_attr( get_option( 'adbx_advarics_webshopsynch_minutes' ) );
	   ?>
			<input type="radio" name="adbx_advarics_webshopsynch" value="0" <?php checked(0, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('disabled','wooadvarics-plugin'); ?><br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="1" <?php checked(1, get_option('adbx_advarics_webshopsynch'), true); ?>>5 min<br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="2" <?php checked(2, get_option('adbx_advarics_webshopsynch'), true); ?>>15 min<br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="3" <?php checked(3, get_option('adbx_advarics_webshopsynch'), true); ?>>30 min<br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="4" <?php checked(4, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('hourly','wooadvarics-plugin'); ?><br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="5" <?php checked(5, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('3 hours','wooadvarics-plugin'); ?><br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="6" <?php checked(6, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('twice daily','wooadvarics-plugin'); ?><br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="7" <?php checked(7, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('daily','wooadvarics-plugin'); ?><br>
			<input type="radio" name="adbx_advarics_webshopsynch" value="8" <?php checked(8, get_option('adbx_advarics_webshopsynch'), true); ?>><?php _e('weekly','wooadvarics-plugin'); ?><br>
	   <?php
	   		echo '<p style="color:red">';
			_e('To change the schedule you must first disable, save and then choose the new interval, saving the new configuration!','wooadvarics-plugin');
			echo '</p>';

	}
	
	function advaricsynchLog()
	{
	   ?>
		<input type="radio" name="adbx_advarics_log" value="0" <?php checked(0, get_option('adbx_advarics_log'), true); ?> ><?php _e('Disabled','wooadvarics-plugin'); ?>	
		<input type="radio" name="adbx_advarics_log" value="1" <?php checked(1, get_option('adbx_advarics_log'), true); ?> ><?php _e('Enabled','wooadvarics-plugin'); ?>
	   <?php
	   	echo '<p style="color:red">';
		_e('Enable logging only during testing and debugging; check readme.txt for file details.','wooadvarics-plugin');
		echo '</p>';

	}
	
	function advaricSizeAttribute() { 
		
		global $taxonomy_attributes;

		$options = get_option( 'adbx_advarics_size' );
		
		?>
		<select name='adbx_advarics_size'>
		<?php
		foreach($taxonomy_attributes as $item) {
			echo '<option value="'. $item . '" ' . selected($options, $item) . '>' . $item . '</option>';
			//$i++;
		}
		?>	
		</select>
	<?php
	}
	
	function advaricColorAttribute() { 
		
		global $taxonomy_attributes;

		$options = get_option( 'adbx_advarics_color' );
		
		?>
		<select name='adbx_advarics_color'>
		<?php
		foreach($taxonomy_attributes as $item) {
			echo '<option value="'. $item . '" ' . selected($options, $item) . '>' . $item . '</option>';
		}
		?>	
		</select>
	<?php
	}
	
	function advaricColorAttribute2() { 
		
		global $taxonomy_attributes;

		$options = get_option( 'adbx_advarics_color2' );
		
		?>
		<select name='adbx_advarics_color2'>
		<?php
		foreach($taxonomy_attributes as $item) {
			echo '<option value="'. $item . '" ' . selected($options, $item) . '>' . $item . '</option>';
		}
		?>	
		</select>
	<?php
	}
	
	function advaricsGTIN()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_gtin_meta_field' ) );
	   ?>
		<input type="radio" name="adbx_advarics_gtin" value="1" <?php checked(1, get_option('adbx_advarics_gtin'), true); ?> ><?php _e('Default field (adbx_gtin)','wooadvarics-plugin'); ?>
		<br><input type="radio" name="adbx_advarics_gtin" value="2" <?php checked(2, get_option('adbx_advarics_gtin'), true); ?> ><?php _e('Other','wooadvarics-plugin'); ?>
		<input type="text" class="regular-text" name="adbx_advarics_gtin_meta_field" value="<?php echo $value; ?>" placeholder="Custom Wordpress Meta field">
	   <?php
	}
	
	function advaricsBrand()
	{
	   ?>
		<input type="radio" name="adbx_advarics_brand" value="1" <?php checked(1, get_option('adbx_advarics_brand'), true); ?> ><?php _e('Imported as a Product Tag','wooadvarics-plugin'); ?>		
		<input type="radio" name="adbx_advarics_brand" value="2" <?php checked(2, get_option('adbx_advarics_brand'), true); ?> ><?php _e('Imported as a Product Attribute (IMPORTANT: if not set, please create a new attribute with slug="brand")','wooadvarics-plugin'); ?>
	   <?php
	}
	
	function advaricsWooSynchMethod()
	{
	   ?>
		<input type="radio" name="adbx_advarics_changedat_synch" value="1" <?php checked(1, get_option('adbx_advarics_changedat_synch'), true); ?> ><?php _e('Differential (insert new and update only modified products/variants)','wooadvarics-plugin'); ?>	
		<br><input type="radio" name="adbx_advarics_changedat_synch" value="2" <?php checked(2, get_option('adbx_advarics_changedat_synch'), true); ?> ><?php _e('Forced (insert new and force update of all existing products/variants)','wooadvarics-plugin'); ?>
		<br><?php _e('Download from ','wooadvarics-plugin'); ?>	<input type="text" class="regular-text" name="adbx_advarics_changedAt" value="<?php echo get_option('adbx_advarics_changedAt'); ?>" style="width: 12em;"> YYYY-MM-DD HH:mm:ss		
	
		<?php
			echo '<p style="color:red">';
			_e('Use "Forced" only if you need to update even unmodified products! Change date settings to adjust synchronization start','wooadvarics-plugin');

			echo '</p>';
	}
	
	/*
	function advaricsWooSynchMethod()
	{
	   ?>
		<input type="radio" name="adbx_advarics_changedat_synch" value="1" <?php checked(1, get_option('adbx_advarics_changedat_synch'), true); ?> ><?php _e('Differential (downloads only products modified since last synchronization )','wooadvarics-plugin'); ?>	
		<input type="text" class="regular-text" name="adbx_advarics_changedAt" value="<?php echo get_option('adbx_advarics_changedAt'); ?>" style="width: 12em;"> YYYY-MM-DD HH:mm:ss		
		<br><input type="radio" name="adbx_advarics_changedat_synch" value="2" <?php checked(2, get_option('adbx_advarics_changedat_synch'), true); ?> ><?php _e('Full (downloads all products marked as webshop articles)','wooadvarics-plugin'); ?>
	   <?php
	}
	*/
	
	function advaricsVariationID()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_variation_id' ) );
	   ?>
		<p><?php _e('IMPORTANT: this is the key used to identify a product variation (size,color) in Woocommerce','wooadvarics-plugin'); ?></p>
		<p><?php _e('Example: if the Complete Advarics GTIN','wooadvarics-plugin'); ?> = '<b>2000021144101</b>', <?php _e('the short GTIN','wooadvarics-plugin'); ?> = '<b>21144101</b>', <?php _e('the short GTIN without control char', 'wooadvarics-plugin') ?> = '<b>2114410</b>' </p>
		<br><input type="radio" name="adbx_advarics_variation_id" value="1" <?php checked(1, get_option('adbx_advarics_variation_id'), true); ?> ><?php _e('Advarics complete GTIN','wooadvarics-plugin'); ?>
		<br><input type="radio" name="adbx_advarics_variation_id" value="2" <?php checked(2, get_option('adbx_advarics_variation_id'), true); ?> ><?php _e('Short GTIN (without prefix)','wooadvarics-plugin'); ?>
		<br><input type="radio" name="adbx_advarics_variation_id" value="3" <?php checked(3, get_option('adbx_advarics_variation_id'), true); ?> ><?php _e('Short GTIN without last control character','wooadvarics-plugin'); ?>
	   <?php
	}
	
	function advaricsProductListSynch()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_single_item_ID' ) );
	   ?>
		<input type="radio" name="adbx_advarics_productlist_synch" value="1" <?php checked(1, get_option('adbx_advarics_productlist_synch'), true); ?> ><?php _e('All products','wooadvarics-plugin'); ?>
		<br><input type="radio" name="adbx_advarics_productlist_synch" value="2" <?php checked(2, get_option('adbx_advarics_productlist_synch'), true); ?> ><?php _e('Single product (use Advarics GTIN/EAN) to filter','wooadvarics-plugin'); ?>
		<input type="text" class="regular-text" name="adbx_advarics_single_item_ID" value="<?php echo $value; ?>" placeholder="Advarics ArticleID">
	   <?php
	}
	
	function advaricExtraAttributes()
	{
	   ?>
		<input type="radio" name="adbx_advarics_extra_attributes" value="1" <?php checked(1, get_option('adbx_advarics_extra_attributes'), true); ?> ><?php _e('Yes','wooadvarics-plugin'); ?>
		<input type="radio" name="adbx_advarics_extra_attributes" value="2" <?php checked(2, get_option('adbx_advarics_extra_attributes'), true); ?> ><?php _e('No','wooadvarics-plugin'); ?>
	   <?php
	}
	
	function advaricArticleTexts()
	{
	   $value_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
	   ?>
		<input type="radio" name="adbx_advarics_article_texts" value="1" <?php checked(1, get_option('adbx_advarics_article_texts'), true); ?> ><?php _e('As Tag','wooadvarics-plugin'); ?>
		<?php 
		if ( ($value_codice_plugin == 19) OR ($value_codice_plugin == 50) )
		{	
			?><input type="radio" name="adbx_advarics_article_texts" value="3" <?php checked(3, get_option('adbx_advarics_article_texts'), true); ?> ><?php _e('As Attribute','wooadvarics-plugin'); ?>
		<?php }
		?>
		<input type="radio" name="adbx_advarics_article_texts" value="2" <?php checked(2, get_option('adbx_advarics_article_texts'), true); ?> ><?php _e('No','wooadvarics-plugin'); ?>
	  <?php
	}
	
	function advaricsProductSKU()
	{
	   $adbx_product_sku_code = esc_attr( get_option( 'adbx_product_sku_code' ) );
	   ?>
		<p><?php _e('IMPORTANT: this is the key used to identify a product in Woocommerce','wooadvarics-plugin'); ?></p>
		<br><input type="radio" name="adbx_product_sku_code" value="1" <?php checked(1, $adbx_product_sku_code, true); ?> >Advarics ArticleNr
		<br><input type="radio" name="adbx_product_sku_code" value="2" <?php checked(2, $adbx_product_sku_code, true); ?> >Advarics ArticleID
		<br><input type="radio" name="adbx_product_sku_code" value="3" <?php checked(3, $adbx_product_sku_code, true); ?> >Advarics ArticleNr + SupplierColorNo
	  
	  <?php
	}
	
	function advaricsProductType()
	{
	   $adbx_simple_product = esc_attr( get_option( 'adbx_simple_product' ) );
	   ?>
		<p><?php _e('Choose if Advarics Product with only one variation should be handled  as WooCommerce Simple product','wooadvarics-plugin'); ?></p>
		<br><input type="radio" name="adbx_simple_product" value="1" <?php checked(1, $adbx_simple_product, true); ?> ><?php _e('Always as Variable Product','wooadvarics-plugin'); ?>
		<input type="radio" name="adbx_simple_product" value="2" <?php checked(2, $adbx_simple_product, true); ?> ><?php _e('One dimension Product as Simple ','wooadvarics-plugin'); ?>
	  
	  <?php
	}

	/*
	function advaricsWooSynchProcess()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_block_size' ) );
	   ?>
		<input type="radio" name="adbx_advarics_synchprocess" value="1" <?php checked(1, get_option('adbx_advarics_synchprocess'), true); ?> ><?php _e('Immediate (Synch process run directly, wait for it to complete  )','wooadvarics-plugin'); ?>
		<br><input type="radio" name="adbx_advarics_synchprocess" value="2" <?php checked(2, get_option('adbx_advarics_synchprocess'), true); ?> disabled ><?php _e('Background (Synch process run in background)','wooadvarics-plugin'); ?>
		 - block size: <input type="number" class="regular-text" name="adbx_advarics_block_size" value="<?php echo $value; ?>" style="width: 5em;">
	  
	  <?php
	}
	*/
	
	function advaricsWooSynchProcess()
	{
	   $value = esc_attr( get_option( 'adbx_advarics_block_size' ) );
	   ?>
		<input type="radio" name="adbx_advarics_synchprocess" value="1" <?php checked(1, get_option('adbx_advarics_synchprocess'), true); ?> ><?php _e('Immediate (Synch process runs directly,  please wait for it to complete before relaunching it)','wooadvarics-plugin'); ?>
	  <?php
	}
	
	
	function advaricsProductPrices()
	{
	   $adbx_price_update = esc_attr( get_option( 'adbx_price_update' ) );
	   ?>
		<p><?php _e('Choose if Advarics prices will be used to update WooCommerce prices; by default webshop prices always updated','wooadvarics-plugin'); ?></p>
		<br><input type="radio" name="adbx_price_update" value="1" <?php checked(1, $adbx_price_update, true); ?> ><?php _e('Always update webshop prices with Advarics prices','wooadvarics-plugin'); ?>
		<input type="radio" name="adbx_price_update" value="2" <?php checked(2, $adbx_price_update, true); ?> ><?php _e('Insert Advarics prices only during product creation ','wooadvarics-plugin'); ?>
	  
	  <?php
	}
	
	function advaricsOutofstockVariant()
	{
	   $adbx_outofstock_variant = esc_attr( get_option( 'adbx_outofstock_variant' ) );
	   ?>
		<p><?php _e('Choose how to handle out of stock product/variants','wooadvarics-plugin'); ?></p>
		<br><input type="radio" name="adbx_outofstock_variant" value="1" <?php checked(1, $adbx_outofstock_variant, true); ?> ><?php _e('Create/Keep online out of stock Products/Variants','wooadvarics-plugin'); ?>
		<input type="radio" name="adbx_outofstock_variant" value="2" <?php checked(2, $adbx_outofstock_variant, true); ?> ><?php _e('Skip/delete out of stock Products/Variants','wooadvarics-plugin'); ?>
	  
	  <?php
	}
	
}

class AdiabaxLicense {
		
	
	
	public $adiabax_id;
	
	function __construct() {

		$this->adiabax_id =  esc_attr( get_option( 'adbx_license_key' ) );
		


	}
	
	function adbxLicenseActivation()
	{
		
		$licenza_crypt = adbx_python_crypt($this->adiabax_id,'e',1);
		$dominio_crypt = adbx_python_crypt(get_site_url(),'e',1);
		
		$postdata = http_build_query(
		array(
			'dominio' => $dominio_crypt,
			'id_licenza' => $licenza_crypt
			)
		);

		$opts = array('http' =>
			array(
				'method'  => 'POST',
				'header'  => 'Content-Type: application/x-www-form-urlencoded',
				'content' => $postdata
			)
		);
		

		$context  = stream_context_create($opts);
		$url = ADBX_SYNCH_SERVER . 'adiabax-license-activation';
		$contents = file_get_contents($url, false, $context);
		
		$contents = utf8_encode($contents); // JSON

		return $contents;
	}
}