<?php 
ini_set("max_execution_time",600);
/**
 * @package  WooadvaricsPlugin
 */
defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' );

class AdbxWooProductsUpdate {
	
	private $terms = array();
	private $advarics_get_array = array();
	
	public function adbxExecUpdate( $init_blocco, $end_blocco, $contents) {
		
		$results = json_decode($contents, true); // ARRAY
		
		if (array_key_exists( 'success',  $results)) 
		{	
			Logger::adbxWriteLog( 'Synchronization error: ' . $results["message"] );	
			return false;
		}	
		else
		{
			// Get ordini ultimi 3 giorni	
			$order_query_args = array(
				'type' 		=> 'shop_order', 
				'status' 	=> array('wc-completed','wc-processing','wc-pending','wc-on-hold'),
				'date_query' => array(
					'after' => date('Y-m-d', strtotime('-3 days')),
					//'before' => date('Y-m-d', strtotime('today')) 
				),
				'limit' 	=> -1
			);
			
			$orders = wc_get_orders( $order_query_args );
			$prodotti_non_cancellabili = array();
			$adbx_outofstock_variant = get_option('adbx_outofstock_variant');
			
			if  ( $adbx_outofstock_variant == 2) //elenco prodotti non cancellabili
			{
				foreach( $orders as $order )
				{
					$order_id = $order->get_id();
					if ( empty(get_post_meta( $order_id, 'adbx_sent_to_erp', true )))
					{	
						$items = $order->get_items();
						foreach ( $items as $item ) {
							//$product_name = $item->get_name();
							$product_id = $item->get_product_id();
							//$product_variation_id = $item->get_variation_id();
							array_push($prodotti_non_cancellabili, $product_id);
						}
					}
					
				}
			}	
			
			$erp_synch_key_json 	= file_get_contents(ADBX_ERP_KEY_FILE);
			$erp_synch_key_array 	= json_decode($erp_synch_key_json, true); // ARRAY

			$this->output_array = $results;
			$number_of_products = $end_blocco - $init_blocco;
			$number_of_updates 	= 0;
		
			$adbx_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
			$adbx_variation_id 	= esc_attr( get_option( 'adbx_advarics_variation_id' ) );
			
			$num_keys = count($erp_synch_key_array);
			for($i=0;$i<$num_keys; $i++)
			{
				$pos 	= $erp_synch_key_array[$i]['pos'];
				$chiave = $erp_synch_key_array[$i]['key'];
				
				if ( $this->output_array["articles"][$pos]["articleId"] == $chiave) 
				{					
					$single_product_new = new AdbxWooProduct( $this->output_array["articles"][$pos], $adbx_codice_plugin, $adbx_variation_id, $prodotti_non_cancellabili );
					$number_of_updates = $number_of_updates + $single_product_new->adbxWooProductVariation();
					unset( $erp_synch_key_array[$i] );
					update_option( 'adbx_running_synch', date("Y-m-d H:i:s") ); //segnala processo terminato
				}
				
				if ( ($i % 20) == 0 )
				{
					$reindex_json_array = array_values( $erp_synch_key_array ); 
					$temp_json 			= json_encode( $reindex_json_array );
					
					$tmp_file = fopen(ADBX_ERP_KEY_FILE, 'w');  
					fwrite($tmp_file, $temp_json);
					fclose($tmp_file);
				}
				 
		
			}
			
			if ( file_exists(ADBX_ERP_KEY_FILE)  ) 		
				$deleted = unlink(ADBX_ERP_KEY_FILE);
			
			if ( file_exists(ADBX_ERP_FILE)  ) 		
				$deleted = unlink(ADBX_ERP_FILE);
			
			if ( get_option('adbx_img_gallery') == 1 )
				$this->adbxCreateImagesSubsizes();

			Logger::adbxWriteLog( 'Downloaded products: ' . $number_of_products . ' - Updates: ' . $number_of_updates);		
			
			// Invio ordini non sincronizzati
			if ( get_option('adbx_webshop_order_destination') == 1 )
			{
				
				$order_query_args = array(
								'type' 		=> 'shop_order', 
								'status' 	=> array('wc-completed','wc-processing','wc-pending','wc-on-hold'),
								'date_query' => array(
									'after' => date('Y-m-d', strtotime('-3 days')),
									//'before' => date('Y-m-d', strtotime('today')) 
								),
								'limit' 	=> -1
				);
				
				$orders = wc_get_orders( $order_query_args );
				
				
				foreach( $orders as $order )
				{
					$order_id = $order->get_id();
					
					if ( empty(get_post_meta( $order_id, 'adbx_sent_to_erp', true )))
						$this->adbxInviaOrdiniNonSincronizzati( $order_id );						
				}
			}	
				
			// Invio storni parziali
			if ( get_option('adbx_webshop_order_destination') == 1 )
			{	

				$refund_query_args = array(
					'post_type' => 'shop_order',
					'status' 	=> array('wc-refunded','wc-completed'), 
					'date_query' => array(
						'after' => date('Y-m-d', strtotime('-30 days')),
						//'before' => date('Y-m-d', strtotime('today')) 
					),
					'limit' 	=> -1,
					'meta_query' => array(
						array(
							'key' => 'adbx_sent_to_erp',
							'value' => ['1','yes']
						),
					)
				);
				
				$refund = wc_get_orders( $refund_query_args);
				foreach( $refund as $order )
				{
					$order_id = $order->get_id();
					$advarics_order_stauts = get_post_meta( $order_id, 'adbx_sent_to_erp', true );
									
					if ( ($advarics_order_stauts == 1) OR ($advarics_order_stauts == 'yes') )
						$this->adbxStornaPosizioneOrdine( $order );
				}	
				
			}
			
			// Invio storni totali (cancellazione)
			if ( get_option('adbx_webshop_order_destination') == 1 )
			{
				$cancel_query_args = array(
					'type' 		=> 'shop_order', 
					'status' 	=> array('wc-cancelled'), 
					'date_query' => array(
						'after' => date('Y-m-d', strtotime('-30 days')),
						//'before' => date('Y-m-d', strtotime('today')) 
					),
					'limit' 	=> -1
				);

				$order_to_cancel = wc_get_orders( $cancel_query_args);
				foreach( $order_to_cancel as $order )
				{
					$order_id = $order->get_id();
					
					$advarics_order_stauts = get_post_meta( $order_id, 'adbx_sent_to_erp', true );
					if (($advarics_order_stauts == 1) OR ($advarics_order_stauts == 'yes') OR ($advarics_order_stauts == 3))
						$this->adbxStornaOrdine( $order );
				}
			}
			
			/* Gestione allineamento ordini in automatico dopo ogni aggiornamento concluso
			
			if ($num_keys == 0)
			{	
				$conn_instance 	= new AdbxSynchWooAdvarics();
				$synch_ok		= $conn_instance->adbxSynchStatusOrder();
				if ($synch_ok)
				{	
					$conn_instance->adbxUpdateStatusWooOrders(1); // 0 = scheduled
				}
			}
			*/
			return true;
		}
	}	
	
	
	public function adbxInviaOrdiniNonSincronizzati( $order_id )
	{
		require_once plugin_dir_path( __FILE__ ) . 'wooadvarics-plugin-neworder.php';
		$order = new WC_Order( $order_id );
		$orderstat = $order->get_status();
		if ($orderstat != 'cancelled')
			Logger::adbxWriteLog( 'Order nr: ' . $order_id . ' non sent to Advarics in status: '. $orderstat);	
		
		$new_order = new AdvaricsSynchOrder();
		$woo_num_order = $new_order->adbxGetWooOrder( $order_id );
		$json_response = $new_order->adbxCreateErpOrder();
		
		$json_data_array 	= json_decode( $json_response, true);
		$message 			= $json_data_array["message"];
		$order->add_order_note( $message );
		Logger::adbxWriteLog( $message . ' (synch)' );
		
	}
	
	
	public function adbxStornaPosizioneOrdine( $order )
	{
		require_once plugin_dir_path( __FILE__ ) . 'wooadvarics-plugin-neworder.php';
		
		if (!empty($order)) 
		{
			$order_nr	= $order->get_id();
			$items 		= $order->get_items();
			$pos = 1;
			$woo_order 	= new AdvaricsSynchOrder();

			foreach ( $order->get_items() as $item_id => $item ) 
			{
							  
				$item_qty_original	= $item->get_quantity();
				$item_qty_refunded 	= $order->get_qty_refunded_for_item( $item_id );
				$new_qty 			= $item_qty_original + $item_qty_refunded;
			   
			   if ($new_qty == 0)
			   {
					
					Logger::adbxWriteLog( 'Order nr: ' . $order_nr . ' to refund !!!!!!!');	
					$json_response = $woo_order->adbxCancelOrderPosition( $order, $pos );
					
					$json_data_array 	= json_decode( $json_response, true);
					$message 			= $json_data_array["message"];
					$order->add_order_note( $message );
					Logger::adbxWriteLog( $message . ' (synch)' );
					
			   }
			  
				$pos++;
			}
		}

	}
	
	
	public function adbxStornaOrdine( $order )
	{
		require_once plugin_dir_path( __FILE__ ) . 'wooadvarics-plugin-neworder.php';
		
		if (!empty($order)) {
			//Logger::adbxWriteLog( 'Order to delete:' . $order->get_id());
			
			$woo_order = new AdvaricsSynchOrder();
			$json_response = $woo_order->adbxCancelOrder( $order );
			
			$json_data_array 	= json_decode( $json_response, true);
			$message 			= $json_data_array["message"];
			
			$order->add_order_note( $message );
			Logger::adbxWriteLog( $message . ' (synch)' );
		}
	}
	
	public function adbxCreateImagesSubsizes() 
	{
		
		if ( ! function_exists( 'wp_crop_image' ) ) {
			include( ABSPATH . 'wp-admin/includes/image.php' );
		}

		$attachments = get_posts(
			[
				'post_type' => 'attachment',
				'posts_per_page' => -1,
				'fields' => 'ids',
				'meta_query' => [
					[
						'key' => '_wp_attachment_metadata',
						'compare' => 'NOT EXISTS'
					]
				]
			]
		);

		foreach($attachments as $attachment_id)
		{

			$url = get_attached_file($attachment_id);

			if ( (strpos($url, '.svg') !== false) OR (strpos($url, '.tff') !== false) OR (strpos($url, '.css') !== false) )
				continue;

			$attach_data = wp_generate_attachment_metadata($attachment_id, $url);
			wp_update_attachment_metadata( $attachment_id,  $attach_data );
			
		}
	
	}
	
}


class AdbxWooProduct {
	
	protected $product = array();
	
	public $advarics_fields = array();
	
	private $product_advaricsID;
	
	private $product_code;
	
	private $title;
	
	private $excerpt;

	private $content;
	
	private $product_id;
	
	private $adbx_variation_id;
	
	private $adbx_codice_plugin;
	
	private $adv_articleNo;
	
	public $prodotti_no_delete;
	

	function __construct( array $single_product, $adbx_codice_plugin, $adbx_variation_id, $prodotti_non_cancellabili ) {
		
		$this->product 				= $single_product;
		$this->advarics_fields 		= array("","articleNo","articleName","brand","inhouseColorNo","inhouseColorName","supplierColorNo", "supplierColorName","webshopArticleNo");
		$this->product_advaricsID	= $this->product["articleId"];
		$this->product_code 		= $this->product["articleNo"] . '_' . $this->product["inhouseColorNo"];
		$this->adbx_variation_id	= $adbx_variation_id;
		$this->adbx_codice_plugin	= $adbx_codice_plugin;
		$this->adv_articleNo		= $this->product["articleNo"];
		$this->prodotti_no_delete	= $prodotti_non_cancellabili;
		
		if (($this->adbx_codice_plugin == 19) OR ( $this->adbx_codice_plugin == 110))
			$this->soglia_outofstock = 1;
		else
			$this->soglia_outofstock = 0;
	}	
		
	
	public function adbxWooProductVariation() {
		
		$variations 			= count( $this->product["details"] );
		$first_update 			= true;
		$updated_products 		= 0;
		$update_category		= true;
		$update_category_type	= get_option('adbx_product_category');
		$product_instock		= 0;
		$new_product 			= false;
		
		$adbx_outofstock_variant = get_option('adbx_outofstock_variant');
		
		if ( get_option('adbx_price_update') == 2) 
			$price_update = false;
		else
			$price_update = true;
		
		if ( ($variations == 1) AND (get_option('adbx_simple_product') == 2) )
			$product_type = 'simple';
		else
			$product_type = 'variable';
		
		if ($product_type == 'simple') 
		{
			// check se prodotto esiste
			if ( $this->adbxWooProductExists() > 0 ) // esiste prodotto
			{
				if ( ($this->adbxWooProductUpdated( $this->product_id )) AND ( get_option('adbx_advarics_productlist_synch') != 2) AND ( get_option('adbx_advarics_changedat_synch') != 2))
				{
					//Logger::adbxWriteLog( 'Skip: ' . $this->product_id);				
					// do nothing break;
					return 0;
				}
				else
				{				
					if ( get_option('adbx_synch_configuration') == 1 ) 
					{
						// do nothing
						$updateOK = true;
					}	
					elseif 	( get_option('adbx_synch_configuration') == 2 ) 
					{
						$this->adbxWooComposeProduct();
						$updateOK = $this->adbxWooUpdateProductDescription();
						
						/*
						$updateOK = wp_update_post( array(
							'ID' => $this->product_id,
							'post_content' => $this->content, 
							'post_title' => $this->title,
							'post_name' => $this->name,
							'post_excerpt' => $this->excerpt 
						) );
						*/
					}
					
					if ( ($update_category_type == 4) OR ($update_category_type == 5))
					$update_category = false;
				}	
			
			}
			else // prodotto nuovo
			{
				$updateOK 		= $this->adbxWooCreateProduct($product_type);
				$new_product 	= true;
			}	
			
			if ( ( $updateOK ) AND ( $first_update ) )
			{	
				$this->adbxWooUpdateProduct( $update_category, $new_product, $product_type, $price_update, true );
				$first_update = false;
				$new_product = false;
			}		
			
			$updated_products = 1;
		}
		else
		{	
			for($j=0; $j < $variations; $j++)
			{

				$variation_array = array();
				$variation_array = $this->product["details"][$j];
				$variation_id	 = $this->adbxWooGetVariationID($variation_array['gtin']);
				
				// Check se variazione esiste
				$variation_postID = $this->adbxWooVariationsExists( $variation_id );
				if ( $variation_postID > 0) // variation esiste
				{
					$this->product_id = wp_get_post_parent_id( $variation_postID );
					
					if ( ($this->product_id == NULL) OR (get_post_type($this->product_id) <> 'product'))
					{
						Logger::adbxWriteLog( 'ERROR: parent post is not a product: ' . $this->product_id);		
						break;
					}	
					
					
					//if ($this->adbxWooProductUpdated( $this->product_id ))
					if ( ($this->adbxWooProductUpdated( $this->product_id )) AND ( get_option('adbx_advarics_productlist_synch') != 2) AND ( get_option('adbx_advarics_changedat_synch') != 2))
					{
						//Logger::adbxWriteLog( 'Skip: ' . $this->product_id);
						break;
					}	
					
					if ($j == ($variations-1)) //ultima variazione aggiorno prodotto
					{
						if ( get_option('adbx_synch_configuration') == 1 ) 
						{
							// do nothing
							$updateOK = true;
						}	
						elseif 	( get_option('adbx_synch_configuration') == 2 ) 
						{
							$this->adbxWooComposeProduct();
							$updateOK = $this->adbxWooUpdateProductDescription();
							/*
							$updateOK = wp_update_post( array(
								'ID' => $this->product_id,
								'post_content' => $this->content, 
								'post_title' => $this->title,
								'post_name' => $this->name,
								'post_excerpt' => $this->excerpt 
							) );
							*/
						}
						
						if ( ($update_category_type == 4) OR ($update_category_type == 5))
							$update_category = false;
						
						$this->adbxWooUpdateProduct( $update_category, false, $product_type, $price_update, true ); 
						
					}	

					$product_instock = $product_instock + $this->adbxWooUpdateProductVariation( $variation_postID , $variation_array, $price_update);
						
					$updated_products = 1;
					
					// cancello varianti nulle
					if  ( $adbx_outofstock_variant == 2)
					{
						if ( $variation_array["stock"] <= $this->soglia_outofstock) 
						{
							if (in_array($this->product_id, $this->prodotti_no_delete)) {
								//do not delete;
							}
							else
							{	
								// CANCELLA VARIATION
								$term = $variation_array["size"];
								$taxonomy 	= 'pa_'. get_option('adbx_advarics_size'); 
								
								if ( adbxDeleteVariation($variation_postID, $variation_array['gtin'], $term ))
								{
									adbxRemovePostTerm( $this->product_id, $term, $taxonomy );
								}
							}		
						
						}	

					}
						
				}	
				else // variation nuova
				{
					if ( ( $adbx_outofstock_variant == 2) AND ( $variation_array["stock"] <= $this->soglia_outofstock) )
					{	
						//Logger::adbxWriteLog( 'Product Variation with GTIN: ' . $variation_array["gtin"] . ' not created as stock: ' . $variation_array["stock"]);
						if ($j == ($variations-1)) //ultima variazione
						{
							if ( $this->adbxWooProductExists() > 0 ) // esiste prodotto
								$this->adbxWooUpdateProduct( $update_category, false, $product_type, $price_update, true );
						}	
						
						continue;
					}
					
					// check se prodotto esiste
					if ( $this->adbxWooProductExists() > 0 ) // esiste prodotto
					{
						if ( get_option('adbx_synch_configuration') == 1 ) 
						{
							// do nothing
							$updateOK = true;
						}	
						elseif 	( get_option('adbx_synch_configuration') == 2 ) 
						{
							$this->adbxWooComposeProduct();
							$updateOK = $this->adbxWooUpdateProductDescription();
							/*
							$updateOK = wp_update_post( array(
								'ID' => $this->product_id,
								'post_content' => $this->content, 
								'post_title' => $this->title,
								'post_name' => $this->name,
								'post_excerpt' => $this->excerpt 
							) );
							*/
						}
						
						if ( ($update_category_type == 4) OR ($update_category_type == 5))
							$update_category = false;
							
					
					}
					else // prodotto nuovo
					{
						$updateOK 		= $this->adbxWooCreateProduct($product_type);
						$new_product 	= true;
					}	
					
					if ( ( $updateOK ) AND ( $first_update ) )
					{	
						$this->adbxWooUpdateProduct( $update_category, $new_product, $product_type, $price_update, false );
						$first_update = false;
						$new_product = false;
					}	

					// Creazione variation( $variation_array)
					$product_instock = $product_instock + $this->adbxWooCreateProductVariation( $variation_array );
					
					$updated_products = 1;
					
				}	
		
			}	
			
			if ( $adbx_outofstock_variant == 2)
			{	
				if (in_array($this->product_id, $this->prodotti_no_delete)) {
					// do not delete
				}
				else
				{	
					$product = wc_get_product( $this->product_id );
					if ($product)
					{	
						$current_products = $product->get_children();
						if ( count($current_products) == 0)
							adbxDeleteProduct($this->product_id, $force = TRUE);
					}
				}
			}
				
		}

		if (($this->adbx_codice_plugin != 19) AND ( $this->adbx_codice_plugin != 110))
		{
			if  ( ($updated_products > 0) AND ( $product_type == 'variable') )
			{
				$product = wc_get_product( $this->product_id );
				
				if ($product_instock == 0)
					$product->set_stock_status('outofstock');
				elseif 	($product_instock > 0)
					$product->set_stock_status('instock');
					
				$product->save();

			}	
		}	

		
		return $updated_products;
	}
	
	
	public function adbxWooComposeProduct() {
	
		// Create Post Title
		if ( get_option( 'adbx_advaricsProductTitle_1' ) > 0 )
		{
			$pos1 = get_option( 'adbx_advaricsProductTitle_1' )-1;
			$pos2 = get_option( 'adbx_advaricsProductTitle_2' )-1;
			$pos3 = get_option( 'adbx_advaricsProductTitle_3' )-1;

			$this->title = $this->product[$this->advarics_fields["$pos1"]];
			if ( $pos2 > 0) {
				$this->title = $this->product[$this->advarics_fields["$pos1"]] . ' - ' . $this->product[$this->advarics_fields["$pos2"]];
				if ( $pos3 > 0) 
					$this->title = $this->product[$this->advarics_fields["$pos1"]] . ' - ' . $this->product[$this->advarics_fields["$pos2"]] .  ' - ' . $this->product[$this->advarics_fields["$pos3"]];
			}
		}
		else	
			$this->title = $this->product["brand"] . ' - ' . $this->product["articleName"];
		
		
		if (($this->adbx_codice_plugin == 19) OR ( $this->adbx_codice_plugin == 30))
		//if ( $this->adbx_codice_plugin == 30)
		{
			$gender_arr	= array('Herren','Damen','Kinder');
			$marke 		= $this->product["brand"];
			$artname	= $this->product["articleName"];
			//$farbe		= $this->product["inhouseColorName"];
			$farbe		= $this->product["supplierColorName"];
			$gender		= '';	
			
			$num_attributes = count( $this->product['articleAttributs'] );
			for ($j=0;$j<$num_attributes;$j++)
			{	
				if ( $this->product['articleAttributs'][$j]['typeName'] == 'F_Geschlecht' )
				{
					$gender_value = $this->product['articleAttributs'][$j]['value'];
					if (in_array($gender_value,$gender_arr))
						$gender = $gender_value;
					break;
				}	
			}	
			
			if ($gender)
				$this->name = $marke . '-' . $gender . '-' . $artname . '-' . $farbe;
			else
				$this->name = $marke . '-' . $artname . '-' . $farbe;

			
		}
		else
			$this->name = $this->title;
		
		// Post Excerpt
		$exploded_excerpt = explode( "%", get_option( 'adbx_advaricsProductExcerpt' ) );
		$this->excerpt = '';
		foreach($exploded_excerpt as $item) {
			if ( (in_array($item, $this->advarics_fields)) AND ($item <> '') )
				$this->excerpt = $this->excerpt . $this->product["$item"];
			else
				$this->excerpt = $this->excerpt . $item;
		}
		
		// Post Content
		if ( get_option('adbx_new_product_content') == 1 )
			$this->content 	= $this->product["description1"];
		elseif 	( get_option('adbx_new_product_content') == 2 )
			$this->content 	= '';
	}
	
	
	private function adbxWooGetVariationID( $gtin ) {
		
		switch ( $this->adbx_variation_id ) {
			case 1:
				$variation_id = $gtin;
				break;
			case 2:
				$local_gtin = substr($gtin, 0, 13);
				$variation_id = substr($local_gtin, stripos($local_gtin,'0'));
				$variation_id = (int)$variation_id;
				break;
			case 3:
				$local_gtin = substr($gtin, 0, 12);
				$variation_id = substr($local_gtin, stripos($local_gtin,'0'));
				$variation_id = (int)$variation_id;
				break;
		}

		return $variation_id;
	}
	
	
	/*
	private function adbxWooVariationsExists( $variation_id ) {
		
		$query_args = array(
		'post_type'  => 'product_variation',
		'post_status' => array('draft','publish'),
		'meta_query' => array(
			array(
				'key'   => '_sku',
				'value' => $variation_id,
				),
			)
		);
	
		$query = new WP_Query( $query_args );	
		if ( $query->have_posts() ) 
			$post_id = $query->post->ID;
		else
			$post_id = 0;
		
	
		return $post_id;
	}
	*/
	
	private function adbxWooVariationsExists( $variation_id ) 
	{
		
		$query_args = array(
		'post_type'  => 'product_variation',
		'post_status' => array('draft','publish'),
		'meta_query' => array(
			array(
				'key'   => '_sku',
				'value' => $variation_id,
				),
			)
		);
	
		$query = new WP_Query( $query_args );	
		if ( $query->have_posts() ) 
		{	
			$post_id = $query->post->ID;
			if (( $this->adbx_codice_plugin == 110 ) OR ( $this->adbx_codice_plugin == 19))
			{
				$parent_id = wp_get_post_parent_id( $post_id );
				$current_status = get_post_status ( $parent_id );
				if ( 'draft' === $current_status )
				{	
				  $my_post = array(
					  'ID'           => $parent_id,
					  'post_status' => 'publish'
				  );
				  // Update the post into the database
				  wp_update_post( $my_post );
				  Logger::adbxWriteLog( 'Status changed from draft to publish, ProductId: ' . $parent_id);	
				}	

			} 
		}	
		else
			$post_id = 0;
		
		return $post_id;
	}
	
	public function adbxWooCreateProductVariation( $variation_details ) {
		
		// non crea variante senza stock
		/*
		$adbx_outofstock_variant = get_option('adbx_outofstock_variant');
		if ( ( $adbx_outofstock_variant == 2) AND ( $variation_details["stock"] <= $this->soglia_outofstock) )
		{	
			//Logger::adbxWriteLog( 'Product Variation with GTIN: ' . $variation_details["gtin"] . ' not created as stock: ' . $variation_details["stock"]);
			return 0;
		}	
		*/
		
		$variation_instock = 0;
		
		$this->size_slug = get_option('adbx_advarics_size');
		if (( $this->adbx_codice_plugin == 20 ) OR ( $this->adbx_codice_plugin == 999999 ))
			if ( $this->product["webShopCategory2"] == 'Schlafsäcke' )
				$this->size_slug = 'reissverschlussseite';
		
		/*	
		if (( $this->adbx_codice_plugin == 30 ) OR ( $this->adbx_codice_plugin == 19 ))
			$normalized_size = str_replace(',', '_', $variation_details["size"]);
		else
			$normalized_size = $variation_details["size"];
		*/
	
		$this->variation_data =  array(
			'attributes' => array(
			//	$this->size_slug  => $normalized_size
				$this->size_slug  => $variation_details["size"]
			),
			'sku'           => $this->adbxWooGetVariationID($variation_details["gtin"]),
			'advarics_gtin' => $variation_details["gtin"],
			'regular_price' => $variation_details["recommendedPrice"],
			'sale_price'    => $variation_details["price"],
			'stock_qty'     => $variation_details["stock"],
		);

		$product = wc_get_product( $this->product_id );
			
		$variation_post = array(
		'post_title'  => $product->get_name(),
		'post_name'   => 'product-'. $this->product_id . '-variation',
		'post_status' => 'publish',
		'post_parent' => $this->product_id,
		'post_type'   => 'product_variation',
		'guid'        => $product->get_permalink()
		
		
		);

		$variation_postID = wp_insert_post( $variation_post );
		if ( $variation_postID )
		{
			$variation = new WC_Product_Variation( $variation_postID );
					
			foreach ( $this->variation_data['attributes'] as $attribute => $term_name )
			{
				
				// Create attribute taxonomy (size, color ecc) if not exists
				$taxonomy 	= 'pa_'. $attribute; 
				
				$taxonomies = get_terms( array(
				'taxonomy' => $taxonomy,
				'hide_empty' => false
				) );

				if( ! taxonomy_exists( $taxonomy ) )
				{
						register_taxonomy($taxonomy,'product_variation',
						array(
							'hierarchical' => false,
							'label' => ucfirst( $attribute ),
							'query_var' => true,
							'rewrite' => array( 'slug' => sanitize_title($attribute) ), 
						)
					);
					
				}
				
				$esiste_slug = false;
				foreach( $taxonomies as $size_attribut ) 
				{
					$size_name	= esc_attr( $size_attribut->name );
					//$size_slug 	= esc_attr( $size_attribut->slug );
					//$size_id 	= esc_attr( $size_attribut->term_id );
					if ($term_name == $size_name)
					{	
						$esiste_slug = true;
						break;
					}	
				}
				
				if ($esiste_slug == false)
				{	
					$term_id = wp_insert_term( $term_name, $taxonomy );
					Logger::adbxWriteLog( 'New size attribute: ' . $term_name . ' created' );
				}	
				
				$post_term_names =  wp_get_post_terms( $this->product_id, $taxonomy, array('fields' => 'names') );
				if( ! in_array( $term_name, $post_term_names ) )
				{	
					$term_slug = get_term_by('name', $term_name, $taxonomy )->slug;
					$esito = wp_set_post_terms( $this->product_id, $term_slug, $taxonomy, true );
					$attribute_slug = 'attribute_' . $taxonomy;
					//update_post_meta( $variation_postID, 'attribute_' . $taxonomy, $term_slug );
					update_post_meta( $variation_postID, $attribute_slug, $term_slug );
					sleep(1);	
					$attribute_slug_caricato = get_post_meta($variation_postID, $attribute_slug, true);
					if ($attribute_slug_caricato != $term_slug)
					{
						Logger::adbxWriteLog( 'WARNING: Different variation slug for VariatioID: ' . $variation_postID . ' of ProductID:' . $this->product_id );
					}	
	
			    }
			

				/*
				if( ! term_exists( $term_name, $taxonomy ) )
					wp_insert_term( $term_name, $taxonomy ); 
				
				
				if ( get_term_by('name', $term_name, $taxonomy )) 
				{
					//$term_slug = get_term_by('slug', $term_name, $taxonomy )->slug; 

					$post_term_names =  wp_get_post_terms( $this->product_id, $taxonomy, array('fields' => 'names') );

					if( ! in_array( $term_name, $post_term_names ) )
					{	
						$esito = wp_set_post_terms( $this->product_id, $term_slug, $taxonomy, true );
						echo '<br>not in array for prod:' .  $this->product_id;
					}	
					
					update_post_meta( $variation_postID, 'attribute_' . $taxonomy, $term_slug );	
				}
				else
					echo '<br>not get term: ' . $term_name . ' $taxonomy' . $taxonomy;
				*/			
			}	
			
			if( ! empty( $this->variation_data['sku'] ) )
				$variation->set_sku( $this->variation_data['sku'] );
			
			if( empty( $this->variation_data['sale_price'] ) )
				$variation->set_price( $this->variation_data['regular_price'] );
			else {
				$variation->set_price( $this->variation_data['sale_price'] );
				$variation->set_sale_price( $this->variation_data['sale_price'] );
			}
			
			$variation->set_regular_price( $this->variation_data['regular_price'] );
			
			if ( ( ! empty($this->variation_data['stock_qty']) ) AND ($this->variation_data['stock_qty'] > $this->soglia_outofstock) )
			{
				$variation->set_stock_quantity( $this->variation_data['stock_qty'] );
				$variation->set_manage_stock(true);
				$variation->set_stock_status('instock');
				$variation_instock++;
			} 
			else {
				$variation->set_manage_stock(false);
				$variation->set_stock_status('outofstock');
				//Logger::adbxWriteLog( 'Variation: ' . $variation_postID . ' set to outofstock!');
			}
			
			update_post_meta( $variation_postID, 'adbx_gtin', $this->variation_data['advarics_gtin'] );
			
			if ( get_option('adbx_advarics_gtin') == 2 ) 
				update_post_meta( $variation_postID, get_option('adbx_advarics_gtin_meta_field') , $this->variation_data['advarics_gtin'] );


			$variation->set_weight(''); 
			$variation->save(); 
			
			$logstring = 'New variation prodid: ' . $this->product_id . ' sku: ' . $this->variation_data['sku'] . ' stock_qty: ' . $this->variation_data['stock_qty'];
			//Logger::adbxWriteLog( $logstring );
			
			//return true;
		}	
		/*else
			return false;
		*/
		return $variation_instock;
	}

						
	
	/*
	private function adbxWooProductExists() {
		
		$query_args = array(
			'post_type'  => 'product',
			'post_status' => array('draft','publish'),
			'meta_query' => array(
				array(
					'key'   => 'adbx_advarics_articleId',
					'value' => $this->product_advaricsID,
				),
			)
		);

		$query = new WP_Query( $query_args ); // Custom Loop 	
		if ( $query->have_posts() ) 
			$this->product_id = $query->post->ID;
		else
			$this->product_id = 0;
		
		return $this->product_id;
	}
	*/
	
	private function adbxWooProductExists() 
	{
		
		$query_args = array(
			'post_type'  => 'product',
			'post_status' => array('draft','publish'),
			'meta_query' => array(
				array(
					'key'   => 'adbx_advarics_articleId',
					'value' => $this->product_advaricsID,
				),
			)
		);

		$query = new WP_Query( $query_args ); 	
		if ( $query->have_posts() ) 
		{	
			$this->product_id = $query->post->ID;
			// customization
			if (( $this->adbx_codice_plugin == 110 ) OR ( $this->adbx_codice_plugin == 19))
			{
				$current_status = get_post_status ( $this->product_id );
				if ( 'draft' === $current_status )
				{	
				  $my_post = array(
					  'ID'           => $this->product_id,
					  'post_status' => 'publish'
				  );
				  // Update the post into the database
				  wp_update_post( $my_post );
				  Logger::adbxWriteLog( 'Status changed from draft to publish, ProductId: ' . $this->product_id);	
				}	
			}	
		}	
		else
			$this->product_id = 0;
		
		return $this->product_id;
	}
	
	function adbxWooProductUpdated( $post_id ) {
		
		$advarics_changed_at 	= $this->product["changedAt"];
		$adbx_woo_changed_at	= get_post_meta( $post_id, 'adbxchangedAt', true );

		if ($advarics_changed_at == $adbx_woo_changed_at)
			return true;
		else
			return false;
		
	}
	
	
	public function adbxWooCreateProduct( $product_type) {
		
		// non crea variante senza stock
		$adbx_outofstock_variant = get_option('adbx_outofstock_variant');
		
		if ( ( $adbx_outofstock_variant == 2) AND ($product_type == 'simple') AND ( $this->product["details"][0]['stock'] <= $this->soglia_outofstock) )
		{	
			//Logger::adbxWriteLog( 'Simple Product with GTIN: ' . $this->product["details"][0]['gtin'] . ' not created as out of stock: ' . $this->product["details"][0]['stock']);
			return false;
		}
		
		$adbx_product_sku_code = get_option('adbx_product_sku_code');

		if ($adbx_product_sku_code == 1)
			$adbx_product_sku = $this->adv_articleNo;
		elseif ($adbx_product_sku_code == 3)
			$adbx_product_sku = $this->adv_articleNo . '-' . $this->product["supplierColorNo"];
		else
			$adbx_product_sku = $this->product_advaricsID;
		
		$this->adbxWooComposeProduct();
		
		$advarics_changed_at = $this->product["changedAt"];
		
		$product_data = array(
			'post_content' => $this->content,
			'post_title' => $this->title,
			'post_name' => $this->name,
			'post_parent' => '',
			'post_type' => "product",
			'post_excerpt' => $this->excerpt,
			'meta_input' 	  	=> array(
				'product_code'				=> $this->product_code,
				'adbx_advarics_articleId' 	=> $this->product_advaricsID,
				'_sku' 						=> $adbx_product_sku,
				'adbxchangedAt'				=> $advarics_changed_at,
				'articleNo'					=> $this->adv_articleNo
			)
		);
		
		if ( get_option('adbx_new_product_status') == 1 )
			$product_data['post_status'] = "draft";
		elseif 	( get_option('adbx_new_product_status') == 2 )
			$product_data['post_status'] = "publish";
			
		//set_time_limit(0);	
		$this->product_id = wp_insert_post( $product_data );
		
		if ($this->product_id) 
		{
			
			if (! empty($this->product["recommendedPrice"]) )
			{	
				update_post_meta( $this->product_id, '_regular_price', $this->product["recommendedPrice"] );
				update_post_meta( $this->product_id, '_price', $this->product["recommendedPrice"] );
			}
			
			if (! empty($this->product["price"]) )
			{	
				update_post_meta( $this->product_id, '_sale_price', $this->product["price"] );
				update_post_meta( $this->product_id, '_price', $this->product["price"] );
			}	
			
			update_post_meta( $this->product_id,'_visibility','visible');

			//wp_set_object_terms( $this->product_id, 'variable', 'product_type');
			wp_set_object_terms( $this->product_id, $product_type, 'product_type');
			
			if ($product_type == 'simple')
			{
				if ( ( ! empty($this->product["details"][0]['stock']) ) AND ($this->product["details"][0]['stock'] > $this->soglia_outofstock) )
				{
					update_post_meta( $this->product_id, "_manage_stock", "yes");
					update_post_meta( $this->product_id, '_stock', $this->product["details"][0]['stock'] );
					update_post_meta( $this->product_id, '_stock_status', 'instock');
				}
				else
				{
					update_post_meta( $this->product_id, "_manage_stock", "false");
					update_post_meta( $this->product_id, '_stock_status', 'outofstock');
					//Logger::adbxWriteLog( 'Product: ' . $this->product_id . ' set to outofstock!');
				}	
				
				// Memorizza gtin e size della variante zero
				update_post_meta( $this->product_id, 'adbx_onedimension_gtin', $this->product["details"][0]['gtin'] );
				update_post_meta( $this->product_id, 'adbx_onedimension_size', $this->product["details"][0]['size'] );
			}	
			
		//	$logstring = 'New ' . $product_type . ' product ' . $this->title . '(Woo_ID:' . $this->product_id . ', AdvaricsID:' . $this->product_advaricsID . ') created.';
			$logstring = 'New ' . $product_type . ' product ' . $this->title . '(Woo_ID:' . $this->product_id . ', AdvaricsID:' . $this->product_advaricsID . ') created' . ', variations->' . count( $this->product["details"] );
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"> 
				<p><strong>' . $logstring . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Nascondi questa notifica.</span></button></div>';
			
			Logger::adbxWriteLog( $logstring );
			
			return $this->product_id;
		}	
		else
		{	
			$logstring = 'ERROR creating new product ' . $this->title . '(AdvaricsID:' . $this->product_advaricsID . ')';
			echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"> 
				<p><strong>' . $logstring . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Nascondi questa notifica.</span></button></div>';
			
			Logger::adbxWriteLog( $logstring );
			
			
			return false;
		}	
		
	}
	
	public function adbxWooUpdateProduct( $update_category, $new_product, $product_type, $price_update, $update_changeAt ) 
	{
				
		$adbx_outofstock_variant = get_option('adbx_outofstock_variant');
		if ( ($product_type == 'simple') AND ( $adbx_outofstock_variant == 2) AND ( $this->product["details"][0]['stock'] <= $this->soglia_outofstock) )
		{
			if (in_array($this->product_id, $this->prodotti_no_delete)) {
				//  do not delete
			}
			else
				adbxDeleteProduct($this->product_id, $force = TRUE);
			
			return 0;
		}	
		
		
		// attributi precedenti
		$tmpBk = get_post_meta($this->product_id, '_product_attributes',true);
		
		$advarics_changed_at = $this->product["changedAt"];
		
		// Update categoria
		if ( $update_category )
			$this->adbxWooSetCategory();
				
		// Update immagini
		$adbx_img_management = get_option('adbx_img_gallery');
		
		switch ($adbx_img_management) {
			case 1:
				$this->adbxWooAttachProductThumbnail();
				break;
			case 2:
				break;
			case 3:
				$this->adbxWooAttachProductThumbnail();
				break;
			case 4:
				if ($new_product)
					$this->adbxWooAttachProductThumbnail();
				break;
			default:
				break;			
		}
				
		
		// Update size attribute
		$size_attrib = 'pa_' . get_option('adbx_advarics_size');
		
		if (( $this->adbx_codice_plugin == 20 ) OR ( $this->adbx_codice_plugin == 999999))
			if ( $this->product["webShopCategory2"] == 'Schlafsäcke' )
			{	
				$size_attrib = 'pa_reissverschlussseite';
			}	
	
		
		// Update color attribute 1 inhouseColorName
		$color_attrib 	= 'pa_' . get_option('adbx_advarics_color');
		
		$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $this->product["inhouseColorName"], $color_attrib, true );
		
		// Update color attribute 2 supplierColorName
		$color_attrib2 	= 'pa_' . get_option('adbx_advarics_color2');
		
		$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $this->product["supplierColorName"], $color_attrib2, true );
		
		
		$the_attributes = array(
			 $size_attrib => array( 
				   'name'=>$size_attrib, 
				   'value'=>'',
				   'is_visible' => '1',
				   'is_variation' => '1',
				   'is_taxonomy' => '1'
			 ),
			 $color_attrib => array( 
				   'name'=>$color_attrib, 
				   'value'=>'',
				   'is_visible' => '1',
				  // 'is_variation' => '1',
				   'is_taxonomy' => '1'
			 ),
			 $color_attrib2 => array( 
				   'name'=>$color_attrib2, 
				   'value'=>'',
				   'is_visible' => '1',
				  // 'is_variation' => '1',
				   'is_taxonomy' => '1'
			 )
		);
		
		
		// Update Gender PB
		if (($this->adbx_codice_plugin == 10) OR ( $this->adbx_codice_plugin == 19))
		{
			$brand_attribute = 'pa_gender';
			$gender_prefix	= substr($this->product["goodsGroupName"],0,1); // D or U or X	
			//$pb_brand_slug = $this->product["brand"] . '-' . $gender_prefix;
			//$pb_brand_slug = $this->product["brand"] . '-' . substr($this->product["goodsGroupName"],0,1); // D or U or X	
			
			switch ( $gender_prefix ) 
			{
				case 'D':
					$gender	= 'women';
					break;
				case 'U':
					$gender	= 'men';
					break;
				default:
					$gender	= 'unisex';
					break;
			} 
			
			
			$the_attributes[$brand_attribute] = array( 
			   'name'=> $brand_attribute, 
			   'value'=> $gender,
			   'is_visible' => '1',
			   //'is_variation' => '1',
			   'is_taxonomy' => '1'
			);
		
			$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $gender, $brand_attribute, true );
			
		}
		
		// Update Brand
		if ( get_option('adbx_advarics_brand') == 1 ) 
			wp_set_object_terms( $this->product_id, array( $this->product["brand"] ), 'product_tag', true);
		elseif ( get_option('adbx_advarics_brand') == 2 ) 
		{
			if (($this->adbx_codice_plugin == 30) OR ( $this->adbx_codice_plugin == 999 ))
				$brand_attribute = 'pa_marke';
			elseif (($this->adbx_codice_plugin == 10) OR ( $this->adbx_codice_plugin == 19 ))
				$brand_attribute = 'pwb-brand';
			else 
				$brand_attribute = 'pa_brand';
			
			// Brand name
			$brand = $this->product["brand"];
		
			// 10 Customization
			if (($this->adbx_codice_plugin == 10) OR ( $this->adbx_codice_plugin == 19))
				$brand_slug = $this->product["brand"] . '-' . substr($this->product["goodsGroupName"],0,1); // D or U or X	
			else 
				$brand_slug = $brand;
			
			//$brand_obj = term_exists( $brand, $brand_attribute );
			$brand_obj = term_exists( $brand_slug, $brand_attribute );
			if( $brand_obj == NULL )
			{
				$brand_obj = wp_insert_term(
					  $brand, 
					  $brand_attribute, 
					  array(
						'description'=> $brand,
						'slug' 		=> $brand_slug
					  )
					);
				
			}
			
			// 10 Customization
			if (($this->adbx_codice_plugin == 10) OR ( $this->adbx_codice_plugin == 19))
			{		
				if ($brand_obj['term_id'])
				{
					$brand_gender = get_post_meta($brand_obj['term_id'],'_gender', true );
					if ($brand_gender)
					{
						Logger::adbxWriteLog( 'Gender: ' . $gender . ', brand: ' . $brand . ', brand_gender: ' . $brand_gender);	
	
						if (($brand_gender == $gender) OR ($brand_gender == 'unisex'))
						{
							// do nothing
						}
						else
						{	
							update_post_meta( $brand_obj[term_id], '_gender', 'unisex' );
							Logger::adbxWriteLog( 'Gender: ' . $gender . ' modificato per brand: ' . $brand);	
						}	
						
					}
					else
					{	
						update_post_meta( $brand_obj[term_id], '_gender', $gender );
						Logger::adbxWriteLog( 'Gender: ' . $gender . ' nuovo per brand: ' . $brand);	
					}	
				}	
			}
			
			$the_attributes[$brand_attribute] = array( 
			   'name'=> $brand_attribute, 
			   'value'=> $brand,
			   'is_visible' => '1',
			   //'is_variation' => '1',
			   'is_taxonomy' => '1'
			);
			
			$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $brand_slug, $brand_attribute, true );
			
			// 10 Customization
			/*
			if (($this->adbx_codice_plugin == 10) OR ( $this->adbx_codice_plugin == 19))
				$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $brand_slug, $brand_attribute, true );
			else
				$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $brand, $brand_attribute, true );

			//$this->adbxWooRegisterBrand('pa_brand');
			*/

		}
			
			
		// Perfect Brands customization	
		if ( ( get_option('adbx_pwb_active'))  AND ($this->adbx_codice_plugin != 19))
			$this->adbxWooRegisterBrand('pwb-brand');
		
		
		// Update extra attribute
		if ( get_option('adbx_advarics_extra_attributes') == 1)
		{	
			$num_extra_attrib = count( $this->product["articleAttributs"] );
			if ( $num_extra_attrib > 0)
			{	
				$attrib_type_array = array();
				$extra_attributes_global = unserialize(get_option('adbx_extra_attributes_table' ));
				
				for ($i = 0; $i < $num_extra_attrib; $i++)
				{
					$attrib_typeName 	= $this->product["articleAttributs"][$i]['typeName'];
					$attrib_value 		= $this->product["articleAttributs"][$i]['value'];
					
					if (array_key_exists( $attrib_typeName,  $extra_attributes_global)) 
					{
						if (array_key_exists( $attrib_typeName,  $attrib_type_array)) 
							$attrib_type_array[$attrib_typeName] = $attrib_type_array[$attrib_typeName] . ' | ' .  $attrib_value;
						else
							$attrib_type_array[$attrib_typeName] = $attrib_value;
					}	
				}	

				foreach($attrib_type_array as $key => $value)
				{
				  $typekey = $key;
				  if ($extra_attributes_global[$typekey])
				  {
					$extra_attrib_slug = 'pa_' . $extra_attributes_global[$typekey];
					
					$attribute_values = explode("|", $value);
					$term_taxonomy_ids 	= wp_set_object_terms( $this->product_id, $attribute_values, $extra_attrib_slug, false );
				
					$the_attributes[$extra_attrib_slug] = array( 
						   'name'=>$extra_attrib_slug, 
						   'value'=> $attribute_values,
						   'is_visible' => '1',
						   //'is_variation' => '1',
						   'is_taxonomy' => '1'
					);
				  
				  }	
				}

			}	
		}


		// Update extra textts
		if ( get_option('adbx_advarics_article_texts') == 3)
		{	
			$num_extra_attrib = count( $this->product["articleTexts"] );
			if ( $num_extra_attrib > 0)
			{	
				$attrib_type_array = array();
				$extra_attributes_global = unserialize(get_option('adbx_extra_texts_table' ));
				
				for ($i = 0; $i < $num_extra_attrib; $i++)
				{
					$attrib_typeName 	= $this->product["articleTexts"][$i]['typeName'];
					$attrib_value 		= $this->product["articleTexts"][$i]['value'];
					
					if (array_key_exists( $attrib_typeName,  $extra_attributes_global)) 
					{
						if (array_key_exists( $attrib_typeName,  $attrib_type_array)) 
							$attrib_type_array[$attrib_typeName] = $attrib_type_array[$attrib_typeName] . ' | ' .  $attrib_value;
						else
							$attrib_type_array[$attrib_typeName] = $attrib_value;
					}	
				}	

				foreach($attrib_type_array as $key => $value)
				{
				  $typekey = $key;
				  if ($extra_attributes_global[$typekey])
				  {
					$extra_attrib_slug = 'pa_' . $extra_attributes_global[$typekey];
					
					$attribute_values = explode("|", $value);
					$term_taxonomy_ids 	= wp_set_object_terms( $this->product_id, $attribute_values, $extra_attrib_slug, false );
				
					$the_attributes[$extra_attrib_slug] = array( 
						   'name'=>$extra_attrib_slug, 
						   'value'=> $attribute_values,
						   'is_visible' => '1',
						   //'is_variation' => '1',
						   'is_taxonomy' => '1'
					);
				  
				  }	
				}

			}	
		}	
		
		
		//update attributes
		if ($tmpBk)		
			update_post_meta($this->product_id, '_product_attributes', array_merge($tmpBk, $the_attributes) );
		else
			update_post_meta( $this->product_id,'_product_attributes',$the_attributes);
		
		//update article texts
		if ( get_option('adbx_advarics_article_texts') == 1 ) 
		{	
			$num_article_texts = count( $this->product["articleTexts"] );
			if ( $num_article_texts > 0)
			{	
				for ($k = 0; $k < $num_article_texts; $k++)
					wp_set_object_terms( $this->product_id, $this->product["articleTexts"][$k]['value'], 'product_tag', true);
			}	
		}	

		
		
		// aggiornamento prezzi, colore e altri paramenti lato prodotto?
		if ( $price_update )
		{	
			if (! empty($this->product["recommendedPrice"]) )
			{	
				update_post_meta( $this->product_id, '_regular_price', $this->product["recommendedPrice"] );
				update_post_meta( $this->product_id, '_price', $this->product["recommendedPrice"] );
			}
			
			if (! empty($this->product["price"]) )
			{	
				update_post_meta( $this->product_id, '_sale_price', $this->product["price"] );
				update_post_meta( $this->product_id, '_price', $this->product["price"] );
			}
		}
		
		if ($update_changeAt)
		{	
			update_post_meta( $this->product_id,'adbxchangedAt',$advarics_changed_at);
		}
		update_post_meta( $this->product_id,'articleNo', $this->adv_articleNo);
		update_post_meta( $this->product_id,'adbx_advarics_articleId', $this->product_advaricsID);
		update_post_meta( $this->product_id,'product_code', $this->product_code);
		
		
		$product = wc_get_product( $this->product_id );
		if ( ($product_type != $product->get_type()) AND (! $new_product) )
		{	
			wp_set_object_terms( $this->product_id, $product_type, 'product_type');
			Logger::adbxWriteLog( 'ProductId: ' . $this->product_id . ' changed to type: ' . $product_type);	
		}
		
		
		if ($product_type == 'simple')
		{
			if ( ( ! empty($this->product["details"][0]['stock']) ) AND ($this->product["details"][0]['stock'] > $this->soglia_outofstock) )
			{
				update_post_meta( $this->product_id, "_manage_stock", "yes");
				update_post_meta( $this->product_id, '_stock', $this->product["details"][0]['stock'] );
				update_post_meta( $this->product_id, '_stock_status', 'instock');
				
			}
			else
			{
				update_post_meta( $this->product_id, "_manage_stock", "false");
				update_post_meta( $this->product_id, '_stock_status', 'outofstock');
				//Logger::adbxWriteLog( 'Product: ' . $this->product_id . ' set to outofstock!');
			}	
			
			update_post_meta( $this->product_id, 'adbx_onedimension_gtin', $this->product["details"][0]['gtin'] );
			update_post_meta( $this->product_id, 'adbx_onedimension_size', $this->product["details"][0]['size'] );
		}
		
		
			$logstring = 'Update ' . $product_type . ' product ' . $this->title . '(Woo_ID:' . $this->product_id . ', AdvaricsID:' . $this->product_advaricsID . ') created' . ' variations->' . count( $this->product["details"] );;
			//Logger::adbxWriteLog( $logstring );
			
	}	
	
	
	
	public function adbxWooRegisterBrand($taxonomy)
	{
		$brand = $this->product["brand"];
		
		$brand_id_obj = term_exists( $brand, $taxonomy );
		
		if( $brand_id_obj == NULL )
		{
			$brand_obj = wp_insert_term(
				  $brand, 
				  $taxonomy, 
				  array(
					'description'=> $brand,
					'slug' 		=> $brand
				  )
				);
			
		}
		
		$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $brand, $taxonomy, true );

	}
	
	
	public function adbxWooSetCategory() {
		
		$category_type = get_option('adbx_product_category');
		
		if ( $category_type == 1 ) { // One single category ( goodsGroupName ) 
		
			$category 	= $this->product["goodsGroupName"];
			$slug 		= str_replace(' ', '_', strtolower( $category ));			
			$cat_id 	= $this->adbxWooRegisterCategory( 0, $category, $slug, $category );
		}
		elseif 	(( $category_type == 2 ) OR ( $category_type == 5 ))
		{ // Advarics WebShop categories
		//elseif 	( $category_type == 2 ) { // Advarics WebShop categories
			
			$category_1 = $this->product["webShopCategory1"];
			$category_2 = $this->product["webShopCategory2"];
			$category_3 = $this->product["webShopCategory3"];
			
			$terms = get_the_terms($this->product_id, 'product_cat');
			if ($terms) 
				foreach ( $terms as $term ) {
					wp_remove_object_terms($this->product_id, $term->term_id, 'product_cat');
				}

			if ( $category_1 <> ''){
				$slug_category_1 = str_replace(' ', '_', strtolower( $category_1 ));		
				$cat_id_master 	= $this->adbxWooRegisterCategory( 0, $category_1, $slug_category_1, $category_1 );
				if ( $category_2 <> ''){
					$slug_category_2 = str_replace(' ', '_', strtolower( $category_2 )) . '-' . $slug_category_1;		
					$cat_id_level_1	= $this->adbxWooRegisterCategory( $cat_id_master, $category_2, $slug_category_2, $category_2 );
					if ( $category_3 <> ''){
						
					//$slug_category_3 =  str_replace(' ', '_', strtolower( $category_3_slug )) . '-' . $slug_category_2;	
					$slug_category_3 =  str_replace(' ', '_', strtolower( $category_3 )) . '-' . $slug_category_2;	

					$cat_id_level_2	= $this->adbxWooRegisterCategory( $cat_id_level_1, $category_3, $slug_category_3, $category_3 );
					}	
				}
				
			}
			
		}
		elseif 	( $category_type == 3 )
			$this->adbxCustomCategory_PB();
		elseif 	( $category_type == 6 ) //Aktivsport Permalink Manager
			$this->adbxCustomCategory_AKTVSP();
		elseif 	( $category_type == 7 )
		{
			$terms = get_the_terms($this->product_id, 'product_cat');
			if ($terms) 
				foreach ( $terms as $term ) {
					wp_remove_object_terms($this->product_id, $term->term_id, 'product_cat');
				}

			$category_array 	= array();
			$category_tree 		= $this->product["webShopCategory1"];
			if ( $category_tree <> '')
			{
				$category_array 	= explode("|", $category_tree);
				$livelli_catgorie	= count($category_array);
				if ($livelli_catgorie > 0)
				{
					
					$id_categoria_padre = 0;
					$slug_categoria 	= '';
					foreach($category_array as $categoria)
					{
						if ($slug_categoria == '')
							$slug_categoria = str_replace(' ', '_', strtolower( trim($categoria) ));
						else
							$slug_categoria = str_replace(' ', '_', strtolower( trim($categoria) )) . '-' . $slug_categoria;		
						
						$id_categoria_padre	= $this->adbxWooRegisterCategory( $id_categoria_padre, $categoria, $slug_categoria, $categoria );
					}
					
				}	
			}
		}
			


	}
	

	private function adbxWooRegisterCategory( $parent_cat, $category, $slug, $category_desc )
	{
	
		$category_type = get_option('adbx_product_category');
		$category_id_obj = term_exists( $slug, 'product_cat', $parent_cat );
		
		if( $category_id_obj == NULL )
		{
			$category_obj = wp_insert_term(
				  $category, 
				  'product_cat', 
				  array(
					'description'=> $category_desc,
					'slug' 		=> $slug,
					'parent'    => $parent_cat,
				  )
				);
			$category_id = $category_obj["term_id"];
		}
		else 
		{	
			$category_id = $category_id_obj["term_id"];
		}	

		$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $slug, 'product_cat', true );
		
		return $category_id;
		
	}
	
	
	private function adbxWooRegisterCategory_AKTVSP( $parent_cat, $category, $slug, $category_desc )
	{
	
		$category_type = get_option('adbx_product_category');
		$category_id_obj = term_exists( $slug, 'product_cat', $parent_cat );
		
		if( $category_id_obj == NULL )
		{
			$category_obj = wp_insert_term(
				  $category, 
				  'product_cat', 
				  array(
					'description'=> $category_desc,
					'slug' 		=> $slug,
					'parent'    => $parent_cat,
				  )
				);
			$category_id = $category_obj["term_id"];
		}
		else 
		{	
			$category_id = $category_id_obj["term_id"];
		}	


		$caty_slug 	= esc_attr( get_term($category_id, 'product_cat')->slug );
		$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $caty_slug, 'product_cat', true );
		//$term_taxonomy_ids = wp_set_object_terms( $this->product_id, $slug, 'product_cat', true );
		
		return $category_id;
		
	}
	
	
	
	public function adbxCustomCategory_AKTVSP() 
	{
		
		$category_1 = $this->product["webShopCategory1"];
		$category_2 = $this->product["webShopCategory2"];
		$category_3 = $this->product["webShopCategory3"];
		
		$terms = get_the_terms($this->product_id, 'product_cat');
		if ($terms) 
			foreach ( $terms as $term ) {
				wp_remove_object_terms($this->product_id, $term->term_id, 'product_cat');
			}
			
		if ( $category_1 <> ''){
			$slug_category_1 = str_replace(' ', '_', strtolower( $category_1 ));		
			$cat_id_master 	= $this->adbxWooRegisterCategory_AKTVSP( 0, $category_1, $slug_category_1, $category_1 );
			if ( $category_2 <> '')
			{
				//$slug_category_2 = $slug_category_1 . "/" . str_replace(' ', '_', strtolower( $category_2 ));	
				$slug_category_2 = str_replace(' ', '_', strtolower( $category_2 ));						
				$cat_id_level_1	= $this->adbxWooRegisterCategory_AKTVSP( $cat_id_master, $category_2, $slug_category_2, $category_2 );
				if ( $category_3 <> '')
				{
					//$slug_category_3 =  $slug_category_2 . "/" . str_replace(' ', '_', strtolower( $category_3 ));	
					$slug_category_3 =  str_replace(' ', '_', strtolower( $category_3 ));	
					$cat_id_level_2	= $this->adbxWooRegisterCategory_AKTVSP( $cat_id_level_1, $category_3, $slug_category_3, $category_3 );
				}	
			}
			
		}	
	
	}	
	
	
	public function adbxCustomCategory_PB() {
		
		$composed_cat	= $this->product["goodsGroupName"];		
		$category_1		= substr($composed_cat,0,1); // D or U or X
		
		$sub_catergories = substr($composed_cat,2);
		$subcat_array	 = explode(" ", $sub_catergories);
		$num_subcat		 = count($subcat_array);
		
		if ($num_subcat > 0)
		{
			$category_2 = $subcat_array[0];
			$sub_cat	= '';
			for ($i = 1; $i < $num_subcat; $i++) 
			{
				$sub_cat = $sub_cat . ' ' . $subcat_array[$i];
			}
			$category_3 = trim($sub_cat);
		}

		$terms = get_the_terms($this->product_id, 'product_cat');
		if ($terms) 
			foreach ( $terms as $term ) {
				wp_remove_object_terms($this->product_id, $term->term_id, 'product_cat');
			}
			
		if ( ( $category_1 == 'U' ) OR ( $category_1 == 'X' ) )
		{
			$category_g = 'Uomo';
			//
			//Logger::adbxWriteLog('product_id: ' . $this->product_id . ' - ' . $category_g .  ' - ' . $category_2 . ' - ' . $category_3);
			$slug_category_1 = str_replace(' ', '_', strtolower( $category_g ));	
			$cat_id_master 	= $this->adbxWooRegisterCategory( 0, $category_g, $slug_category_1, $category_g );
			if ( $category_2 <> '')
			{
				//$slug_category_2 = $slug_category_1 . '-' . str_replace(' ', '_', strtolower( $category_2 ));	
				$slug_category_2 = str_replace(' ', '_', strtolower( $category_2 )) . '-' . $slug_category_1;	
				$cat_id_level_1	= $this->adbxWooRegisterCategory( $cat_id_master, $category_2, $slug_category_2, $category_2 );
				if ( $category_3 <> '')
				{
					//$slug_category_3 = $slug_category_2 . '-' . str_replace(' ', '_', strtolower( $category_3 ));
					$slug_category_3 =  str_replace(' ', '_', strtolower( $category_3 )) . '-' . $slug_category_2;					
					$cat_id_level_2	= $this->adbxWooRegisterCategory( $cat_id_level_1, $category_3, $slug_category_3, $category_3 );
				}	
			}

		}
		
		
		if ( ( $category_1 == 'D' ) OR ( $category_1 == 'X' ) )
		{
			$category_g = 'Donna';
			//Logger::adbxWriteLog('product_id: ' . $this->product_id . ' - ' . $category_g .  ' - ' . $category_2 . ' - ' . $category_3);
			$slug_category_1 = str_replace(' ', '_', strtolower( $category_g ));
			$cat_id_master 	= $this->adbxWooRegisterCategory( 0, $category_g, $slug_category_1, $category_g );
			if ( $category_2 <> '')
			{
				$slug_category_2 = str_replace(' ', '_', strtolower( $category_2 )) . '-' . $slug_category_1;		
				$cat_id_level_1	= $this->adbxWooRegisterCategory( $cat_id_master, $category_2, $slug_category_2, $category_2 );
				if ( $category_3 <> '')
				{
					$slug_category_3 =  str_replace(' ', '_', strtolower( $category_3 )) . '-' . $slug_category_2;	
					$cat_id_level_2	= $this->adbxWooRegisterCategory( $cat_id_level_1, $category_3, $slug_category_3, $category_3 );
				}	
			}

		}
		
	}	
	
	
	public function adbxWooAttachProductThumbnail(){
		
		$images 			= array();
		$img_gallery_array 	= array();
		//$special_chars		= [' ','/',',','.'];
		$special_chars		= [' ','/',',','.','\'','&','`'];
		$images_composition = get_option('adbx_img_name');
		
		$all_img_ids = get_posts( 
		array(
			'post_type'      => 'attachment', 
			'post_mime_type' => 'image', 
			'post_status'    => 'inherit', 
			'posts_per_page' => -1,
			'fields'         => 'ids',
			) 
		);

		foreach ( $all_img_ids as $id )
			$images[get_the_title($id)] = $id;
			
		$image_url	= $this->product["picturePath"];
		$num_pics 	= count($this->product["articlePictures"]);
	
		if ( ($image_url == '') AND ($num_pics== 0))
			return;
		else 
		{
			//main img
			$main_id_img	= get_post_thumbnail_id( $this->product_id );
			if ($main_id_img)
				array_push($img_gallery_array, $main_id_img);

			//gallery
			$productm = new WC_product($this->product_id);
			$attachment_ids = $productm->get_gallery_image_ids();
			foreach( $attachment_ids as $attachment_id ) 
				array_push($img_gallery_array, $attachment_id);
		
			if ($num_pics == 0) //only main img
			{
				if (filter_var($image_url, FILTER_VALIDATE_URL) ) 
				{
					$url_array 	= explode('/',$image_url);
					$image_name = $url_array[count($url_array)-1];
					$path_parts = pathinfo($image_url);
					$image_extension  = $path_parts['extension'];
					
					if ($image_extension <> '') 
					{
						//image_name_seo
						if ($images_composition == 2)
						{	
							$image_name = str_replace($special_chars, '', trim($this->product["brand"])) . '-' . str_replace($special_chars, '', trim($this->product["articleName"])); 
							if ($this->product["supplierColorName"])
								$image_name = $image_name . '-' . str_replace($special_chars, '', trim($this->product["supplierColorName"])); 
		
							$image_name = $image_name . '.' . $image_extension;

						}
						
						$attach_id = $this->adbxGetImgID( $images, strtolower($image_name), $image_url );
						
						if ( !in_array( $attach_id, $img_gallery_array ))
							set_post_thumbnail( $this->product_id, $attach_id );
					}
				} 
	
			}
			else
			{
				for($j=0; $j < $num_pics; $j++)
				{
					$typeNo		= $this->product["articlePictures"][$j]["typeNo"]; // Type (1 main pictures, from 2 gallery)
					$image_url 	= $this->product["articlePictures"][$j]["picturePath"];  // Remote image URL
					if (filter_var($image_url, FILTER_VALIDATE_URL) ) 
					{
						$url_array 	= explode('/',$image_url);
						$image_name = $url_array[count($url_array)-1];
						$path_parts = pathinfo($image_url);
						$image_extension  = $path_parts['extension'];
						
						//image_name_seo
						if ($images_composition == 2)
						{	
							$image_name = str_replace($special_chars, '', trim($this->product["brand"])) . '-' . str_replace($special_chars, '', trim($this->product["articleName"])); 
							
							if ($this->product["supplierColorName"])
							{
								$harmonized_supplierColorName = str_replace($special_chars, '', trim($this->product["supplierColorName"]));
								if ($harmonized_supplierColorName <> '')
									$image_name = $image_name . '-' . str_replace($special_chars, '', trim($this->product["supplierColorName"])); 
							}	
					
							$image_name = $image_name . '-' . $typeNo; 

							$image_name = $image_name . '.' . $image_extension;
						}
						elseif ($images_composition == 3)
						{	
							$image_name = str_replace($special_chars, '', trim($this->product["brand"])) . '-' . str_replace($special_chars, '', trim($this->product["articleName"])); 
							if ($this->product["supplierColorName"])
								$image_name = $image_name . '-' . str_replace($special_chars, '', trim($this->product["supplierColorName"])); 
							if ($this->product["articleNo"])
								$image_name = $image_name . '-' . str_replace($special_chars, '', trim($this->product["articleNo"])); 
		
							$image_name = $image_name . '-' . $typeNo; 

							$image_name = $image_name . '.' . $image_extension;
						}
						
						$attach_id = $this->adbxGetImgID( $images, strtolower($image_name), $image_url );
						
						if ( ( !in_array( $attach_id, $img_gallery_array )) AND ($attach_id > 0) )
						{

							if( $typeNo == 1)
								set_post_thumbnail( $this->product_id, $attach_id );
							elseif( $typeNo > 1 )
							{ 
								$attach_id_array = get_post_meta($this->product_id,'_product_image_gallery', true);
								$attach_id_array .= ',' . $attach_id;
								update_post_meta($this->product_id,'_product_image_gallery',$attach_id_array);
							}
							
						}
					}
				}	
				
			}	
		}
	}	


	public function adbxGetImgID( $images, $image_name, $image_url)
	{
		
		if(get_http_response_code($image_url) != "200"){
			Logger::adbxWriteLog( $image_url . ' - No such file, 404 Http Error');		
			return 0;
		} 
		
		$image_name = str_replace('%c3%bc', 'ue', $image_name);
		$image_name = str_replace('ü', 'ue', $image_name);
		$image_name = str_replace('%c3%b6', 'oe', $image_name);
		$image_name = str_replace('ö', 'oe', $image_name);
		$image_name = str_replace('%c3%a4', 'ae', $image_name);
		$image_name = str_replace('ä', 'ae', $image_name);
		$image_name = str_replace('ß', 'ss', $image_name);
		$image_name = str_replace('+', 'plus', $image_name);
		//$image_name = str_replace('\'', '', $image_name);
		//$image_name = str_replace('&', '', $image_name);
		

		if ( isset($images[$image_name]) )
		{
			//Logger::adbxWriteLog( 'EXISTS image: ' . $image_name);	

			return $images[$image_name];
		}
		else	
		{
			$image_data = file_get_contents($image_url); 	
			$upload_dir = wp_upload_dir(); 
			$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name ); 
			$filename = basename( $unique_file_name ); 
			if( wp_mkdir_p( $upload_dir['path'] ) ) {
				$file = $upload_dir['path'] . '/' . $filename;
			} else {
				$file = $upload_dir['basedir'] . '/' . $filename;
			}
			
			
			file_put_contents( $file, $image_data );
			
			$wp_filetype = wp_check_filetype( $filename, null );
			
			$attachment = array(
				'post_mime_type' => $wp_filetype['type'],
				'post_title' => sanitize_file_name( $filename ),
				'post_content' => '',
				'post_status' => 'inherit'
			);
			
			$attach_id = wp_insert_attachment( $attachment, $file );

			Logger::adbxWriteLog( 'New orignal image: ' . $image_name . ' (id: ' . $attach_id . ' )');	
			
			return $attach_id;
		}	
	}
	

	public function adbxWooUpdateProductVariation( $variation_postID, $variation_data, $price_update ){
		
		$variation_instock = 0;
		
		$variation = new WC_Product_Variation( $variation_postID );
		
		$size_attrib_taxonomy = 'pa_' . get_option('adbx_advarics_size');
		$attribute_slug = 'attribute_' . $size_attrib_taxonomy;
		$attribute_slug_caricato = get_post_meta($variation_postID, $attribute_slug, true);
		if ($attribute_slug_caricato == '')
		{	
			Logger::adbxWriteLog( 'WARNING: Null variation slug for VariatioID: ' . $variation_postID . ' of ProductID: ' . $this->product_id . ' $taxonomy: ' . $size_attrib_taxonomy . ' $term_slug:' . $attribute_slug_caricato);	
		}
		
		if ($price_update) 
		{
			if( empty( $variation_data['price'] ) )
				$variation->set_price( $variation_data['recommendedPrice'] );
			else {
				$variation->set_price( $variation_data['price'] );
				$variation->set_sale_price( $variation_data['price'] );
			}
			
			$variation->set_regular_price( $variation_data['recommendedPrice'] );	
		}	
		
		if ( ( ! empty($variation_data['stock']) ) AND ($variation_data['stock'] > $this->soglia_outofstock) )
		{
			$variation->set_stock_quantity( $variation_data['stock'] );
			$variation->set_manage_stock(true);
			$variation->set_stock_status('instock');
			$variation_instock++;
		} 
		else {
			$variation->set_manage_stock(false);
			$variation->set_stock_status('outofstock');
			//Logger::adbxWriteLog( 'Variation (update): ' . $variation_postID . ' set to outofstock!');	
		}
		
		
		update_post_meta( $variation_postID, 'adbx_gtin', $variation_data['gtin'] );
			
		if ( get_option('adbx_advarics_gtin') == 2 ) 
				update_post_meta( $variation_postID, get_option('adbx_advarics_gtin_meta_field') , $variation_data['gtin'] );

		
		$variation->set_weight(''); 
		$variation->save(); 
		
		return $variation_instock;
		
	}
	
	
	public function adbxWooUpdateProductDescription() {
	
		if ($this->content != '')
		{
			$updateOK = wp_update_post( array(
				'ID' => $this->product_id,
				'post_content' => $this->content, 
				'post_title' => $this->title,
				'post_name' => $this->name,
				'post_excerpt' => $this->excerpt 
			) );	
		}
		else
		{
			$updateOK = wp_update_post( array(
				'ID' => $this->product_id,
				//'post_content' => $this->content, 
				'post_title' => $this->title,
				'post_name' => $this->name
				//'post_excerpt' => $this->excerpt 
			) );	
		}	
		
		return $updateOK;
	}	
		
}