<?php 
/**
 * @package  WooerpPlugin
 */
defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' );

//require ADBX_WOOGS_PLUGIN_PATH . 'inc/wooadvarics-plugin-config.php';

//date_default_timezone_set("CET");


class Logger {
	
	static function adbxWriteLog( $logstring ){	

		$log = get_option( 'adbx_advarics_log' );
		if ($log == 1)
		{
			$logfile = fopen(ADBX_LOG_FILE, 'a');  
			fwrite($logfile, "\n" . date('d-m-Y H:i:s') . ' ->' . $logstring);
			fclose($logfile); 	
		}
	}
	
}

function adbx_python_crypt( $string, $action, $e_method ) {

	$secret_key	= SKEY;
	$secret_iv	= SIV;
	
    $output = false;
	switch ($e_method) {
		case 0: $encrypt_method = "AES-256-CBC";
				break;
		case 1: $encrypt_method = "AES-128-CBC";
				break;
		default:		
				$encrypt_method = "AES-128-CBC";
				break;
	}
	
    if( $action == 'e' ) {
		$output = base64_encode( openssl_encrypt( $string, $encrypt_method, $secret_key,OPENSSL_RAW_DATA, $secret_iv ) );

    }
    else if( $action == 'd' ){
		$output = openssl_decrypt( base64_decode( $string ), $encrypt_method, $secret_key, OPENSSL_RAW_DATA, $secret_iv );
    }
    return $output;
}


function adbx_run_servertemplate( $url, $parameter_array )
{
	
	$postdata = http_build_query( $parameter_array );
	
	$opts = array('http' =>
		array(
			'method'  => 'POST',
			'header'  => 'Content-Type: application/x-www-form-urlencoded',
			'content' => $postdata,
			'timeout' => 300
		)
	);
	
	$context = stream_context_create( $opts );
	
	$response = file_get_contents($url, false, $context);
	
	return $response;
	
}


function adbx_print_filecontent( $logfile )
{
	$log_text = '';
	
	if ( file_exists( $logfile) )
	{
		$file = file($logfile);
		for ($i = max(0, count($file)-ADBX_PRINTLOG_BLOCK); $i < count($file); $i++)
			$log_text = $log_text . '<br>' . $file[$i];
	}
		
	if ( file_exists(ADBX_ERP_KEY_FILE) )
		$log_text = $log_text . '<br>' . date('d-m-Y H:i:s') . ' ->' . 'Keyfile size: ' . filesize(ADBX_ERP_KEY_FILE) . ' bytes';

	return $log_text;
}


function get_http_response_code($url) {
    $headers = get_headers($url);
    return substr($headers[0], 9, 3);
}

function adbx_delete_file( $logfile )
{
	if ( file_exists( $logfile) )
	{	
		unlink($logfile);
		return true;
	}
	else
		return false;
}


/**
 * Method to delete Woo Product
 * 
 * @param int $id the product ID.
 * @param bool $force true to permanently delete product, false to move to trash.
 * @return \WP_Error|boolean
 */
function adbxDeleteProduct($id, $force = FALSE)
{
   
	$product = wc_get_product($id);
	// immagine principale
	$id_img_principale = get_post_thumbnail_id( $id );
	if ($id_img_principale)
	{	
		wp_delete_attachment( $id_img_principale );
		Logger::adbxWriteLog( 'Main image with id: ' . $id_img_principale . ' deleted for product: ' . $id);
	}
	
	$gallery_image_ids = $product->get_gallery_image_ids();
	if ( !empty( $gallery_image_ids ) ) {
		foreach ( $gallery_image_ids as $gallery_image_id ) {
			wp_delete_attachment( $gallery_image_id );
			Logger::adbxWriteLog( 'Gallery img with id: ' . $gallery_image_id . ' deleted for product: ' . $id);
		}
	}
	
	// If we're forcing, then delete permanently.
    if ($force)
 	{
        if ($product->is_type('variable'))
        {
            foreach ($product->get_children() as $child_id)
            {
                $child = wc_get_product($child_id);
                $child->delete(true);
            }
        }
        elseif ($product->is_type('grouped'))
        {
            foreach ($product->get_children() as $child_id)
            {
                $child = wc_get_product($child_id);
                $child->set_parent_id(0);
                $child->save();
            }
        }

        $product->delete(true);
        $result = $product->get_id() > 0 ? false : true;
    }
    else
    {
        $product->delete();
        $result = 'trash' === $product->get_status();
    }

    if (!$result)
    {
        return new WP_Error(999, sprintf(__('This %s cannot be deleted', 'woocommerce'), 'product'));
    }

    // Delete parent product transients.
    if ($parent_id = wp_get_post_parent_id($id))
    {
        wc_delete_product_transients($parent_id);
    }
	
	Logger::adbxWriteLog( 'Product with ID: ' . $id . ' deleted!');
	
    return true;
}


function adbxDeleteVariation( $variation_id, $variation_gtin, $term )
{
	$variation_post = get_post( $variation_id );

	if ( $variation_post && $variation_post->post_type == 'product_variation' ) 
	{
		/*
		if (wp_trash_post( $variation_id ))
		{	
			Logger::adbxWriteLog( 'Variation with ID: ' . $variation_id . ' deleted!');
			return true;
		}
		else 
			return false;
		*/
		$child = wc_get_product($variation_id);
		$child->delete(true);
		Logger::adbxWriteLog( 'Variation ' . $term . ' with GTIN: ' . $variation_gtin . ' deleted!');
		return true;
        

	}
}	


function adbxRemovePostTerm( $post_id, $term, $taxonomy ) {

	$new_terms = array();
	
	$term_object = get_term_by( 'slug', $term , $taxonomy );
	
	$term_name 		= $term_object->name;
	$term_id 		= $term_object->term_id;
	$current_terms 	= wp_get_object_terms( $post_id, $taxonomy, array( 'fields' => 'ids' ) );
	foreach ( $current_terms as $current_term ) {
		if ( $current_term != $term_id )
			$new_terms[] = intval( $current_term );
	}
	
	wp_set_object_terms( $post_id, $new_terms, $taxonomy );
	//Logger::adbxWriteLog( 'Term: ' . $term . ' for product: ' . $post_id . ' deleted!');
}