<!-- WooAdvarics Plugin setting page -->
<?php

defined( 'ABSPATH' ) or die( 'Hey, what are you doing here? You silly human!' );
//require ADBX_PLUGIN_PATH . 'inc/wooadvarics-plugin-synch.php';
require ADBX_PLUGIN_PATH . 'inc/wooadvarics-plugin-neworder.php';
//require ADBX_PLUGIN_PATH . 'inc/wooadvarics-plugin-config.php';
?>

<div class="wrap">
	<h1>Woocommerce Advarics Integration</h1>
	<?php settings_errors(); ?>
	
	<?php 
		$adbx_license = esc_attr( get_option( 'adbx_license_key' ) );
		if ( ($adbx_license == '') OR ( is_null($adbx_license)) )
			$adbx_license_print = '<b>WARNING</b>: No license has been activated!';
		else
		{	
			$adbx_license_print = $adbx_license;
			//$adbx_codice_plugin = esc_attr( get_option( 'adbx_codice_plugin' ) );
		}	
		
		$adbx_codice_plugin = get_option( 'adbx_codice_plugin' ) ? esc_attr( get_option( 'adbx_codice_plugin' ) ) : '';

		//WPML Check
		/*$wpml_options = get_option( 'icl_sitepress_settings' );
		$default_lang = $wpml_options['default_language'];
		$current_language = apply_filters( 'wpml_current_language', NULL );
		$manualsynch_button_display = '';
		
		if (($default_lang) AND ($default_lang <> $current_language ))
			$manualsynch_button_display = 'disabled';
		*/
		//WPML Check
		$manualsynch_button_display = '';
		$wpml_options = get_option( 'icl_sitepress_settings' );
		if ($wpml_options)
		{	
			$default_lang = $wpml_options['default_language'];
			$current_language = apply_filters( 'wpml_current_language', NULL );
			if (($default_lang) AND ($default_lang <> $current_language ))
				$manualsynch_button_display = 'disabled';
		}	
		
		
		global $taxonomy_attributes;
		
		$attribute_taxonomies = wc_get_attribute_taxonomies();

		if ( $attribute_taxonomies )
			foreach ($attribute_taxonomies as $tax) 
				if (taxonomy_exists(wc_attribute_taxonomy_name($tax->attribute_name)))
					if (! in_array( $tax->attribute_name, $taxonomy_attributes ))
						array_push( $taxonomy_attributes, $tax->attribute_name);
					
		array_push( $taxonomy_attributes, '');			
					
					
		$last_update = get_option('adbx_advarics_changedAt');			

	?>	

	<h3><i>Adiabax License Key:</i> <b style="color:green;"><?php echo $adbx_license_print . '-' . $adbx_codice_plugin ?></b></h3><br>
	<form method="post" action="options.php">
		
		<?php 
			settings_fields( 'wooadvarics_options_group' );
			do_settings_sections( 'wooadvarics_plugin' );
			submit_button();
		?>
		
	</form>
	

      
    <?php
        
		if(array_key_exists('manual_synch_scheduled', $_POST))
            adbxERPProductSynch();
		elseif (array_key_exists('activate_license', $_POST))
			adbxActivateLicense();
		elseif (array_key_exists('nextschedule', $_POST))
		{
			$text = '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"> 
					<p><strong>Next scheduled products synchronization: ' . gmdate("d-m-Y H:i:s", wp_next_scheduled( 'wooadvarics_cron_hook' )) . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Nascondi questa notifica.</span></button></div>';
			_e($text, 'wooadvarics-plugin');		
		}
		elseif (array_key_exists('order_status_synch', $_POST))
			adbxManualOrderStatusSynch();
		elseif (array_key_exists('setting_export', $_POST))
			adbxSettingExport();
		elseif (array_key_exists('align_systems', $_POST))
			adbxManualAlignment();
		elseif (array_key_exists('delete_prev_synch', $_POST))
			adbxDeletePrevSynch();
		elseif (array_key_exists('create_media_images', $_POST))
			adbxGenerateMediaImages();
		elseif (array_key_exists('print_log', $_POST))
			adbxPrintLog();
		elseif (array_key_exists('delete_log', $_POST))
			adbxDeleteLog();
			
		
			
		function adbxERPProductSynch() {
			
			$synch_process 	= get_option('adbx_advarics_synchprocess');
			$synch_type 	= get_option('adbx_advarics_changedat_synch');
			
			$conn_instance 	= new AdbxSynchWooAdvarics();
			
			
			$synch_ok		= $conn_instance->adbxExecSynchronization( $synch_type );
			if ($synch_ok)
			{	
				if ( $synch_process == 2) //background $conn_instance->adbxBlockSplitAndSchedule();
					$conn_instance->adbxImmediateSynch();
				else	
					$conn_instance->adbxImmediateSynch();
			}
			
		}
		

		function adbxManualOrderStatusSynch() { 

			$conn_instance 	= new AdbxSynchWooAdvarics();
			$synch_ok		= $conn_instance->adbxSynchStatusOrder();
			if ($synch_ok)
			{	
				$conn_instance->adbxUpdateStatusWooOrders(0); // 0 = manual
			}	
			
		}
		
		
		function adbxManualAlignment() { 
			
			$synch_type = 9;
			
			$conn_instance 	= new AdbxSynchWooAdvarics();
			$synch_ok		= $conn_instance->adbxExecSynchronization( $synch_type );
			if ($synch_ok)
				$conn_instance->adbxAlignProducts();
        }
		
		
		function adbxActivateLicense() { 
			
			$result_array = array();
			
			$synch_instance = new AdiabaxLicense();
			$contents = $synch_instance->adbxLicenseActivation();
			$result_array = json_decode($contents, true);
			if  ($result_array["success"])
				echo '<div id="setting-error-settings_updated" class="notice notice-success settings-error is-dismissible"> 
					<p><strong>' . $result_array["message"] . ' - Expiration date: ' . $result_array["expiration date"] . '</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Nascondi questa notifica.</span></button></div>';
			else 
				echo '<div class="error"><p>' . $result_array["message"] . '</p></div>';

        } 
		
		function adbxSettingExport() { 
			
			$options = array();
			$options = ADBX_PLUGIN_WP_OPTIONS;

			$setting_log = 'PLUGIN SETTINGS<br>';
			foreach ($options as $option) 
				if (get_option($option))
					$setting_log = $setting_log . '<br>' . $option . ' ---> ' . get_option($option);
			echo '<div class="notice notice-success settings-error is-dismissible"><p>' . $setting_log . '</p></div>';
			
		}
		
		function adbxDeletePrevSynch() { 
			
			$deleted_key 	= false;
			$deleted_files 	= false;
			
			if ( file_exists(ADBX_ERP_KEY_FILE)  ) 		
			{
				$deleted_key 	= unlink(ADBX_ERP_KEY_FILE);
				Logger::adbxWriteLog( ADBX_ERP_KEY_FILE . ' deleted' );	
			}	
			
			if ( file_exists(ADBX_ERP_FILE)  ) 	
			{
				$deleted_files 	= unlink(ADBX_ERP_FILE);	
				Logger::adbxWriteLog( ADBX_ERP_FILE . ' deleted' );	
			}	
			
			if ($deleted_key OR $deleted_files)
				echo '<div class="notice notice-success settings-error is-dismissible"><p>Previous files deleted</p></div>';

			
		}
		
		
		function adbxGenerateMediaImages() { 
			
			$synch_instance = new AdbxWooProductsUpdate();
			$synch_instance->adbxCreateImagesSubsizes();
			
		}
		
		function adbxPrintLog() { 
			
			$log_content = adbx_print_filecontent( ADBX_LOG_FILE );
			echo '<div class="notice notice-success settings-error is-dismissible"><p>' . $log_content . '</p></div>';
			
		}
		
		function adbxDeleteLog() { 
			
			$log_content = adbx_delete_file( ADBX_LOG_FILE );
			echo '<div class="notice notice-success settings-error is-dismissible"><p>Logfile deleted!</p></div>';
			
		}
		
		
		
    ?> 
  
	<br><hr><br>
    <form method="post"> 
	
	<h3 style="color:yellow;background-color:red;">
	<?php
		if (( file_exists(ADBX_ERP_KEY_FILE)) AND (filesize(ADBX_ERP_KEY_FILE) > 20))
			_e('The previous synchronization has not finished; synchronize again to conclude the previous import and then restart the synchronization.','wooadvarics-plugin');
	?>
	</h3>
	<h1 style="color:green;"> 
        <?php _e('Manual synchronization','wooadvarics-plugin');?>
    </h1> 
	

    <h4> 
        <?php _e('Click the button to synchronize products with Advarics ( last synchronization:','wooadvarics-plugin'); ?> <?php echo $last_update . ')'; ?>
    </h4> 
        <input type="submit" name="manual_synch_scheduled" class="button" value="Synchronize products now!" <?php echo $manualsynch_button_display; ?> /> 
		<input type="submit" name="nextschedule" class="button" value="Check next synchronization schedule" /> 
		<p style="color:red">
		<?php _e('ATTENTION: In the case of a multilingual site, manual synchronization is active only if the default language is selected!','wooadvarics-plugin'); ?></p>

    </form>
	
	<br><hr><br>
    <form method="post"> 
	
	<h1 > 
        <?php _e('Order status synchronization','wooadvarics-plugin'); ?>
    </h1> 
    
	<h4> 
        <?php _e('Click to synchronize order status with Advarics','wooadvarics-plugin'); ?>
    </h4> 
        <input type="submit" name="order_status_synch" class="button" value="Synchronize order status!"  /> 
		<p style="color:red">
    </form>
	
	
	<br><hr><br>
	
    <form method="post"> 
	
	<h1> 
		<?php _e('Manual alignment Advarics-Woocommerce','wooadvarics-plugin'); ?>
    </h1> 
    <h4> 
		<?php _e(' Click to put in "draft" deactivated Advarics products (no longer available for the online store)','wooadvarics-plugin'); ?>
     </h4> 
        <input type="submit" name="align_systems" class="button" value="Align systems!"  /> 
    </form>
	

	<br><hr><br>
    <form method="post"> 
	
	<h1 > 
        <?php _e('WooAdvarics additional features','wooadvarics-plugin'); ?>
    </h1> 
	<h4> 
		<?php _e(' Click to run additional features','wooadvarics-plugin'); ?>
     </h4> 
		<input type="submit" name="delete_prev_synch" class="button" value="Delete previous synch files!" /> 
       <input type="submit" name="create_media_images" class="button" value="Generate media-image sub-sizes!" /> 
 
    </form>
	
	
	<br><hr><br>
    <form method="post"> 
	
	<h1 > 
        <?php _e('Plugin Support & Documentation','wooadvarics-plugin'); ?>
    </h1> 
    <h4> 
		<?php _e('Please send you support requests to ','wooadvarics-plugin'); ?><a href="mailto:support@adiabax.it"> support@adiabax.it</a>, <?php _e('Download documentation: ','wooadvarics-plugin'); ?><a href="https://www.adiabax.it/ea/wooadvarics/docs/WooAdvaricsPlugin_Settings_Deutsch.pdf" target="_blanc">Deutsch</a> - <a href="https://www.adiabax.it/ea/wooadvarics/docs/WooAdvaricsPlugin_Settings_English.pdf" target="_blanc">English</a>
        <br><br><?php _e('Click the button to display plugin settings','wooadvarics-plugin'); ?>
    </h4> 
        <input type="submit" name="setting_export" class="button" value="Display plugin settings!" /> 
		<input type="submit" name="print_log" class="button" value="Display log file!" /> 
		<p style="color:red">
    </form>
	
	<form id="deletelog" method="post"  onsubmit="return confirm('Do you really want to submit the form?');"> 
    <h4> 
      <br><?php _e('Click the button to delete log file','adbxwooerp-plugin'); ?>
    </h4> 
		<input type="submit" name="delete_log" class="button" value="Delete log file!" /> 
		<p style="color:red">
    </form>
	

</div>

